Constraints in JavaScript Diagram control

Constraints are used to enable or disable certain behaviors of the diagram, nodes, and connectors. Constraints are provided as flagged enumerations, so that multiple behaviors can be enabled or disabled using the Bitwise operators (&, |, ~, <<, etc.).

To know more about Bitwise operators, refer to Bitwise Operations.

Diagram constraints

Diagram constraints allows you to enable or disable the following behaviors:

The following table displays the list of all diagram constraints.

Constraints Description
None Disable all diagram functionalities.
Bridging Enables or disables Bridging support for connector in diagram.
Undo/redo Enables or disables the Undo/Redo support for the diagram.
UserInteraction Enables or disables user interaction support for the diagram.
ApiUpdate Enables or disables Api update support for the diagram.
PageEditable Enables or disables Page Editable support for the diagram.
Zoom Enables or disables Zoom support for the diagram.
PanX Enables or disables Panning X coordinate support for the diagram.
PanY Enables or disables Panning Y coordinate support for the diagram.
Pan Enables or disables panning both X and Y coordinates support for the diagram.
ZoomTextEdit Enables or disables zooming the text box while editing the text.
Tooltip Enables or disables the tooltip for the diagram.
Virtualization Enables or disables Virtualization support for the diagram.
LineRouting Enables or disables the line routing.
Default Enables or disables all constraints in diagram.

The following example illustrates how to disable page editing using the diagram constraints.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    constraints: ej.diagrams.DiagramConstraints.Default & ~ej.diagrams.DiagramConstraints.PageEditable
});

The following example shows how to enable Bridging constraint to the default constraints of diagram.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    constraints: ej.diagrams.DiagramConstraints.Default | ej.diagrams.DiagramConstraints.Bridging
});

Multiple behaviors can be added or removed from the default constraints using the Bitwise Operations in the diagram.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    constraints: ej.diagrams.DiagramConstraints.Default & ~(ej.diagrams.DiagramConstraints.PageEditable|ej.diagrams.DiagramConstraints.Zoom);
});

For more information about diagram constraints, refer to DiagramConstraints.

NOTE

By default, the following constraints are enabled in the diagram,

* Zoom

* ApiUpdate

* PanX

* PanY

* Pan

* Undo/Redo

* PageEditable

* Default

Node constraints

Node constraints allows to enable or disable the following behaviors of node. They are as follows:

Constraints Description
None Disable all node Constraints
Select Enables or disables the node to be selected.
Drag Enables or disables the node to be dragged.
Rotate Enables or disables the node to be rotated.
Shadow Enables or disables the node to display shadow.
PointerEvents Enables or disables the node to provide pointer option.
Delete Enables or disables node to be deleted.
InConnect Enables or disables node to provide in connect option.
OutConnect Enables or disables node to provide out connect option.
AllowDrop Enables node to provide allow to drop option.
Individual Enables node to provide individual resize option
ResizeNorthEast Enable or disable to resize NorthEast side of the node.
ResizeEast Enable or disable to resize East side of the node.
ResizeSouthEast Enable or disable to resize SouthEast side of the node.
ResizeSouth Enable or disable to resize South side of the node.
ResizeSouthWest Enable or disable to resize SouthWest side of the node.
ResizeWest Enable or disable to resize West side of the node.
ResizeNorthWest Enable or disable to resize NorthWest side of the node.
ResizeNorth Enable or disable to resize North side of the node.
AspectRatio Enables the Aspect ratio of the node.
ReadOnly Enables the ReadOnly support for annotation in the node.
HideThumbs Enable to hide all resize thumbs for the node.
Tooltip Enables or disables tooltip for the Nodes.
InheritTooltip Enables or disables inherit tooltip option from the parent object.
Resize Enables or Disables the expansion or compression of a node.
Inherit Enables the node to inherit the interaction option from the parent object.
Expandable Enables node to provide Expandable option
AllowMovingOutsideLane Enables or disables child in parent for the swimLane node
Default Enables all default constraints for the node.

The following example illustrates how to disable rotation using the node constraints.

var nodes = [{ id: 'node', offsetX: 100, offsetY: 100, constraints: ej.diagrams.NodeConstraints.Default & ~ej.diagrams.NodeConstraints.Rotate }];
var diagram = new ej.diagrams.Diagram({
    width: '100%, height: 600, nodes: nodes,
},'#element');

The following example shows how to add Shadow constraint to the default constraints of node.

var node = { id: 'node', offsetX: 100, offsetY: 100, constraints: ej.diagrams.NodeConstraints.Default | ej.diagrams.NodeConstraints.Shadow };

The following code example shows how the tooltip can be enabled for the node.

//Enabled the tooltip constraints for the node.
var node = { id: 'node', offsetX: 100, offsetY: 100, tooltip:{content:'Node'}, constraints: ej.diagrams.NodeConstraints.Default | ej.diagrams.NodeConstraints.Tooltip };

Multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

The following code example shows how to remove rotate and resize constraints from node.

 //Removing multiple constraints from default.
var node = { id: 'node', offsetX: 100, offsetY: 100,constraints: ej.diagrams.NodeConstraints.Default &~ (ej.diagrams.NodeConstraints.Rotate | ej.diagrams.NodeConstraints.Resize) };

Refer sample below

ej.diagrams.Diagram.Inject(
  ej.diagrams.UndoRedo,
  ej.diagrams.DiagramContextMenu
);

var diagram;

var nodes = [
  {
    id: 'Node1',
    offsetX: 100,
    offsetY: 100,
    annotations: [{ content: 'Select disabled' }],
    constraints:
      ej.diagrams.NodeConstraints.Default & ~ej.diagrams.NodeConstraints.Select,
  },
  {
    id: 'Node2',
    offsetX: 250,
    offsetY: 100,
    annotations: [{ content: 'Rotate disabled' }],
    constraints:
      ej.diagrams.NodeConstraints.Default & ~ej.diagrams.NodeConstraints.Rotate,
  },
  {
    id: 'Node3',
    offsetX: 400,
    offsetY: 100,
    annotations: [{ content: 'Resize disabled' }],
    constraints:
      ej.diagrams.NodeConstraints.Default & ~ej.diagrams.NodeConstraints.Resize,
  },
  {
    id: 'Node4',
    offsetX: 550,
    offsetY: 100,
    annotations: [{ content: 'Drag disabled' }],
    constraints:
      ej.diagrams.NodeConstraints.Default & ~ej.diagrams.NodeConstraints.Drag,
  },
  {
    id: 'Node5',
    offsetX: 700,
    offsetY: 100,
    annotations: [{ content: 'Tooltip enabled' }],
    constraints:
      ej.diagrams.NodeConstraints.Default | ej.diagrams.NodeConstraints.Tooltip,
    tooltip: { content: 'Node Tooltip', relativeMode: 'Object' },
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  nodes: nodes,
  //Sets the default values of a nodes
  getNodeDefaults: function (obj) {
    obj.width = 100;
    obj.height = 100;
    obj.shape = { shape: 'Ellipse' };
    return obj;
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information about node constraints, refer to NodeConstraints.

NOTE

By default, the following constraints are enabled for the node,

* Select

* Drag

* Resize

* Rotate

* InConnect

* OutConnect

* PointerEvents

* ResizeNorthEast

* ResizeEast

* ResizeSouthEast

* ResizeSouth

* ResizeSouthWest

* ResizeWest

* ResizeNorthWest

* ResizeNorth

* Inherit

* Expandable

* Individual

* InheritTooltip

* Default

Connector constraints

Connector constraints allows you to enable or disable certain behaviors of connectors.

Constraints Description
None Disable all connector Constraints.
Select Enables or disables connector to be selected.
Delete Enables or disables connector to be deleted.
Drag Enables or disables connector to be dragged.
DragSourceEnd Enables connectors source end to be selected.
DragTargetEnd Enables connectors target end to be selected.
DragSegmentThumb Enables control point and end point of every segment in a connector for editing.
Interaction Enables or disables Interaction for the connector.
AllowDrop Enables allow drop support to the connector.
Bridging Enables bridging to the connector.
InheritBridging Enables to inherit bridging option from the parent object.
BridgeObstacle Enables or Disables Bridge Obstacles with overlapping of connectors.
PointerEvents Enables to set the pointer events.
ConnectToNearByNode Enables to connect to the nearest node.
ConnectToNearByPort Enables to connect to the nearest port.
Tooltip Enables or disables tooltip for the connectors.
LineRouting Enables or disables routing to the connector.
InheritLineRouting Enables or disables routing to the connector.
InheritTooltip Enables or disables inherit tooltip option from the parent object
ConnectToNearByElement Enables to connect to the nearest elements.
InheritSegmentThumbShape Enables or disables to inherit the value of segmentThumbShape.
ReadOnly Enables or disables readonly for the connector.
Default Enables all constraints for the connector.

The following code shows how to disable select constraint from the default constraints of connector.

var connectors = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    constraints: ej.diagrams.ConnectorConstraints.Default & ~ej.diagrams.ConnectorConstraints.Select
}];
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600, connectors: connectors,
},'#element');

The following example shows how to add Bridging constraint to the default constraints of connector.

var connector = {
    id: 'connector1',
    type: 'Straight',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    constraints: ej.diagrams.ConnectorConstraints.Default | ej.diagrams.ConnectorConstraints.Bridging
};

NOTE

To visualize connector bridging, we need to inject ConnectorBridgin module.

The following code example shows how the tooltip can be enabled for the connector.

var connector = {
        id: 'connector1',
        type: 'Straight',
        sourcePoint: { x: 100, y: 100 },
        targetPoint: { x: 200, y: 200 },
        tooltip:{content:'Connector'},
        constraints: ej.diagrams.ConnectorConstraints.Default | ej.diagrams.ConnectorConstraints.Tooltip
    };

The connector constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

//Removing multiple constraints from default.
var connector = {
        id: 'connector1',
        type: 'Straight',
        sourcePoint: { x: 100, y: 100 },
        targetPoint: { x: 200, y: 200 },
        tooltip:{content:'Connector'},
        constraints: ej.diagrams.ConnectorConstraints.Default &~ (ej.diagrams.ConnectorConstraints.DragSourceEnd|ej.diagrams.ConnectorConstraints.DragTargetEnd)
    };

Refer sample below

ej.diagrams.Diagram.Inject(ej.diagrams.UndoRedo);

var diagram;

var connectors = [
  {
    id: 'connector1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    type: 'Orthogonal',
    constraints:
      ej.diagrams.ConnectorConstraints.Default &
      ~ej.diagrams.ConnectorConstraints.Select,
    annotations: [{ content: 'Select disabled', alignment: 'After' }],
  },
  {
    id: 'connector2',
    sourcePoint: { x: 250, y: 100 },
    targetPoint: { x: 350, y: 200 },
    type: 'Orthogonal',
    constraints:
      ej.diagrams.ConnectorConstraints.Default &
      ~ej.diagrams.ConnectorConstraints.Drag,
    annotations: [{ content: 'Drag disabled', alignment: 'After' }],
  },
  {
    id: 'connector3',
    sourcePoint: { x: 400, y: 100 },
    targetPoint: { x: 500, y: 200 },
    type: 'Orthogonal',
    constraints:
      ej.diagrams.ConnectorConstraints.Default &
      ~ej.diagrams.ConnectorConstraints.DragSourceEnd,
    annotations: [{ content: 'Source end disabled', alignment: 'After' }],
  },
  {
    id: 'connector4',
    sourcePoint: { x: 550, y: 100 },
    targetPoint: { x: 650, y: 200 },
    type: 'Orthogonal',
    constraints:
      ej.diagrams.ConnectorConstraints.Default &
      ~ej.diagrams.ConnectorConstraints.DragTargetEnd,
    annotations: [{ content: 'Target end disabled', alignment: 'After' }],
  },
  {
    id: 'connector5',
    sourcePoint: { x: 700, y: 100 },
    targetPoint: { x: 800, y: 200 },
    type: 'Orthogonal',
    constraints:
      ej.diagrams.ConnectorConstraints.Default &
      ~ej.diagrams.ConnectorConstraints.Delete,
    annotations: [{ content: 'Delete disabled', alignment: 'After' }],
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  connectors: connectors,
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information about connector constraints, refer to ConnectorConstraints.

NOTE

By default, the following constraints are enabled for the connector,

* Select

* Delete

* Drag

* Interaction

* ConnectToNearByNode

* ConnectToNearByPort

* ConnectToNearByElement

* BridgeObstacle

* InheritBridging

* PointerEvents

* InheritLineRouting

* InheritTooltip

* InheritSegmentThumbShape

* Default

Port constraints

The constraints property of the Port allows you to enable or disable the following behaviors of port.

Constraints Description
None Disable all port Constraints.
Draw Enables to create the connection when mouse hover on the port.
Drag Enables or disables port dragging
InConnect Enables or disables to connect only the target end of connector.
OutConnect Enables or disables to connect only the source end of connector.
ToolTip Enables or disables the Tooltip for the ports.
InheritTooltip Enables or disables the Tooltip for the ports.
Default Enables all constraints for the port.

The following code illustrates how to disable creating connections with a port.

var nodes = [
    {
        id: 'node',
        offsetX: 100,
        offsetY: 100,
        ports: [
            {
                constraints: ej.diagrams.PortConstraints.None
            }
        ]
    }
];
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600, nodes: nodes,
});

The following code example shows how to modify the port constraints to accept target connection alone.

        ports: [
            {   //Enable to create target connection alone.
                constraints: ej.diagrams.PortConstraints.InConnect
            }
        ]

The port constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

        ports: [
            {   //Enable to draw connector from port also accepts both in and out connections.
                constraints: ej.diagrams.PortConstraints.Default | ej.diagrams.PortConstraints.Draw;
            }
        ]

Refer sample below

var diagram;

var nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      { content: 'tooltip enabled', offset: { x: 0.5, y: 0.1 } },
      { content: 'draw enabled', offset: { x: 0.2, y: 0.5 } },
      { content: 'drg enabled', offset: { x: 0.8, y: 0.5 } },
      { content: 'InConnect disabled', offset: { x: 0.2, y: 0.9 } },
      { content: 'OutConnect disabled', offset: { x: 0.8, y: 0.9 } },
    ],
    ports: [
      {
        id: 'left',
        offset: { x: 0, y: 0.5 },
        visibility: ej.diagrams.PortVisibility.Visible,
        constraints:
          ej.diagrams.PortConstraints.Default |
          ej.diagrams.PortConstraints.Draw,
      },
      {
        id: 'right',
        offset: { x: 1, y: 0.5 },
        visibility: ej.diagrams.PortVisibility.Visible,
        constraints:
          ej.diagrams.PortConstraints.Default |
          ej.diagrams.PortConstraints.Drag,
      },
      {
        id: 'top',
        offset: { x: 0.5, y: 0 },
        visibility: ej.diagrams.PortVisibility.Visible,
        constraints:
          ej.diagrams.PortConstraints.Default |
          ej.diagrams.PortConstraints.ToolTip,
        tooltip: { content: 'Port tooltip' },
      },
      {
        id: 'bottomLeft',
        offset: { x: 0.2, y: 1 },
        visibility: ej.diagrams.PortVisibility.Visible,
        constraints:
          ej.diagrams.PortConstraints.Default &
          ~ej.diagrams.PortConstraints.InConnect,
      },
      {
        id: 'bottomRight',
        offset: { x: 0.8, y: 1 },
        visibility: ej.diagrams.PortVisibility.Visible,
        constraints:
          ej.diagrams.PortConstraints.Default &
          ~ej.diagrams.PortConstraints.OutConnect,
      },
    ],
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  nodes: nodes,
  //Sets the default values of a nodes
  getNodeDefaults: function (obj) {
    obj.width = 300;
    obj.height = 200;
    return obj;
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information about port constraints, refer to PortConstraints.

NOTE

By default, the following constraints are enabled for the port,

* InConnect

* OutConnect

Annotation constraints

The constraints property of the Annotations allows you to enable or disable certain behaviors of annotation.

Constraints Description
ReadOnly Enables or disables the ReadOnly Constraints,
InheritReadOnly Enables or disables to inherit the ReadOnly option from the parent object.
Select Enables or Disable select support for the annotation
Drag Enables or Disable drag support for the annotation
Resize Enables or Disable resize support for the annotation
Rotate Enables or Disable rotate support for the annotation
Interaction Enables interaction of annotation
None Disables all constraints for the annotation.

The read-only mode for the annotation is enabled by settings ReadOnly constraints to the annotation.

The following code illustrates how to enable read-only mode for the annotations.

var nodes = [
    {
        id: 'node',
        offsetX: 100,
        offsetY: 100,
        annotations: [
            {
                id: 'anotation_1',
                content: 'annotation',
                constraints: ej.diagrams.AnnotationConstraints.ReadOnly,
            }
        ]
    }
];
var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600, nodes: nodes,
});

Interactions such as select, drag, resize, and rotate can be enabled for the annotation as shown below.

 annotations: [
            {
                id: 'anotation_1',
                content: 'annotation',
                constraints: ej.diagrams.AnnotationConstraints.Select | ej.diagrams.AnnotationConstraints.Drag | ej.diagrams.AnnotationConstraints.Resize |
                ej.diagrams.AnnotationConstraints.Rotate,
            }
        ]

Refer sample below

var diagram;

var nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      {
        content: 'Interaction enabled',
        offset: { x: 0.5, y: 0.1 },
        constraints: ej.diagrams.AnnotationConstraints.Interaction,
      },
      {
        content: 'ReadOnly enabled',
        offset: { x: 0.2, y: 0.5 },
        constraints: ej.diagrams.AnnotationConstraints.ReadOnly,
      },
      {
        content: 'Select and drag enabled',
        offset: { x: 0.8, y: 0.5 },
        constraints:
          ej.diagrams.AnnotationConstraints.Select |
          ej.diagrams.AnnotationConstraints.Drag,
      },
      {
        content: 'Select and rotate enabled',
        offset: { x: 0.5, y: 0.9 },
        constraints:
          ej.diagrams.AnnotationConstraints.Select |
          ej.diagrams.AnnotationConstraints.Rotate,
      },
    ],
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  nodes: nodes,
  //Sets the default values of a nodes
  getNodeDefaults: function (obj) {
    obj.width = 300;
    obj.height = 200;
    return obj;
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more details about annotation constraints, refer to AnnotationConstraints.

Selector constraints

Selector visually represents the selected elements with certain editable thumbs. The visibility of the thumbs can be controlled with selector constraints. The part of selector is categorized as follows:

Constraints Description
None Hides all the selector elements.
ConnectorSourceThumb Shows or hides the source thumb of the connector.
ConnectorTargetThumb Shows or hides the target thumb of the connector.
ResizeSouthEast Shows or hides the bottom right resize handle of the selector.
ResizeSouthWest Shows or hides the bottom left resize handle of the selector.
ResizeNorthEast Shows or hides the top right resize handle of the selector.
ResizeNorthWest Shows or hides the top left resize handle of the selector.
ResizeEast Shows or hides the middle right resize handle of the selector.
ResizeWest Shows or hides the middle left resize handle of the selector.
ResizeSouth Shows or hides the bottom center resize handle of the selector.
ResizeNorth Shows or hides the top center resize handle of the selector.
Rotate Shows or hides the rotate handle of the selector.
UserHandle Shows or hides the user handles of the selector.
ToolTip Shows or hides the default tooltip for the drag, resize, and rotate operation of nodes and connectors.
ResizeAll Shows or hides all resize handles of the selector.
All Shows all handles of the selector.

The following code illustrates how to hide rotator.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    selectedItems: { constraints: ej.diagrams.SelectorConstraints.All & ~ej.diagrams.SelectorConstraints.Rotate}
});

The following code demonstrates how to hide the default tooltip during the drag, resize, and rotate operations on nodes:

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    selectedItems: { constraints: ej.diagrams.SelectorConstraints.All & ~ej.diagrams.SelectorConstraints.ToolTip}
});

The following code example shows how to disable the userhandle functionality for the selected item.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    selectedItems: { constraints: ej.diagrams.SelectorConstraints.All & ~ej.diagrams.SelectorConstraints.UserHandle}
});

Refer sample below

var diagram;

var nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      { content: 'Resize handle disabled in selector constraints' },
    ],
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  nodes: nodes,
  //Sets the default values of a nodes
  getNodeDefaults: function (obj) {
    obj.width = 100;
    obj.height = 100;
    return obj;
  },
  selectedItems: {
    constraints:
      ej.diagrams.SelectorConstraints.All &
      ~ej.diagrams.SelectorConstraints.ResizeAll,
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information about selector constraints, refer to SelectorConstraints.

NOTE

By default, the following constraints are enabled for the selected items,

* Rotate

* UserHandel

* ResizeAll

* All

* ToolTip

Snap constraints

Snap constraints control the visibility of gridlines and enable/disable snapping.

The following list of snapping constraints are used to enable or disable certain features of snapping.

Constraints Description
None Disable snapping for the nodes/connectors in diagram.
ShowHorizontalLines Displays only the horizontal gridlines in diagram.
ShowVerticalLines Displays only the Vertical gridlines in diagram.
ShowLines Display both Horizontal and Vertical gridlines.
SnapToHorizontalLines Enables the object to snap only with horizontal gridlines.
SnapToVerticalLines Enables the object to snap only with Vertical gridlines.
SnapToLines Enables the object to snap with both horizontal and Vertical gridlines.
SnapToObject Enables the object to snap with the other objects in the diagram.
All Shows gridlines and enables snapping.

The following code illustrates how to show only horizontal gridlines.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    snapSettings: {
        constraints: ej.diagrams.SnapConstraints.ShowHorizontalLines
    }
});

The snap constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

  snapSettings: {
        constraints: ej.diagrams.SnapConstraints.ShowHorizontalLines | ej.diagrams.SnapConstraints.ShowVerticalLines
    };

Refer sample below

var diagram;

var nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [{ content: 'Node 1' }],
  },
  {
    id: 'Node2',
    offsetX: 400,
    offsetY: 200,
    annotations: [{ content: 'Node 2' }],
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  nodes: nodes,
  //Sets the default values of a nodes
  getNodeDefaults: function (obj) {
    obj.width = 100;
    obj.height = 100;
    return obj;
  },
  //Snap to object and horizontal gridlines disabled
  snapSettings: {
    constraints:
      ej.diagrams.SnapConstraints.All &
      ~(
        ej.diagrams.SnapConstraints.ShowHorizontalLines |
        ej.diagrams.SnapConstraints.SnapToObject
      ),
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information about snap constraints, refer to SnapConstraints.

NOTE

By default, the following constraints are enabled for the snap functionality in the diagram,

* ShowLines

* ShowVerticalLines

* ShowHorizontalLines

* SnapToLines

* SnapToHorizontalLines

* SnapToVerticalLines

* SnapToObject

* All

Boundary constraints

Boundary constraints defines a boundary for the diagram inside which the interaction should be done.

The following list of constraints are used to enable or disable certain features of boundary interactions of the diagram.

Constraints Description
Infinity Allow the interactions to take place at the infinite height and width.
Diagram Allow the interactions to take place around the diagram height and width.
Page Allow the interactions to take place around the page height and width.

The following code illustrates how to limit the interaction done inside a diagram within a page.

var diagram = new ej.diagrams.Diagram({
    width: '100%', height: 600,
    pageSettings: {
        boundaryConstraints: 'Page'
    }
});

Refer sample below

var diagram;

var nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    width:100,
    height:100,
    annotations: [{ content: 'Node interactions restricted within page' }],
  },
];
//Initialize the diagram
diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: '645px',
  nodes: nodes,
  pageSettings: {
    // Boundary set as page
    boundaryConstraints: 'Page',
    width: 500,
    height: 500,
    showPageBreaks: true,
    background: { color: 'grey' },
  },
});
diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

For more information about selector constraints, refer to BoundaryConstraints.

Inherit behaviors

Some of the behaviors can be defined through both the specific object (node/connector) and diagram. When the behaviors are contradictorily defined through both, the actual behavior is set through inherit options.

The following code example illustrates how to inherit the line bridging behavior from the diagram model.

ej.diagrams.Diagram.Inject(ej.diagrams.ConnectorBridging);
var connectors = [
  {
    id: 'connector1',
    type: 'Straight',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    constraints:
      ej.diagrams.ConnectorConstraints.Default |
      ej.diagrams.ConnectorConstraints.InheritBridging,
  },
  {
    id: 'connector2',
    type: 'Straight',
    sourcePoint: { x: 100, y: 200 },
    targetPoint: { x: 200, y: 100 },
    constraints:
      ej.diagrams.ConnectorConstraints.Default |
      ej.diagrams.ConnectorConstraints.InheritBridging,
  },
];
var diagram = new ej.diagrams.Diagram({
  width: '100%',
  height: 600,
  connectors: connectors,
  constraints:
    ej.diagrams.DiagramConstraints.Default |
    ej.diagrams.DiagramConstraints.Bridging,
});

diagram.appendTo('#element');

Bitwise operations

Bitwise operations are used to manipulate the flagged enumerations enum. In this section, Bitwise operations are shown by using the node constraints. The same is applicable when working connector constraints, or port constraints.

Add operation

You can add or enable multiple values at a time by using Bitwise | (OR) operator.

The following code demonstrates how to add tooltip constraints to the default node constraints, thereby enabling tooltip functionality for the node:

node.constraints = ej.diagrams.NodeConstraints.Default | ej.diagrams.NodeConstraints.Tooltip;

In the previous example, you can perform basic interactions with the node while also enabling tooltip functionality.

Remove Operation

You can remove or disable values by using Bitwise &~ (XOR) operator.

node.constraints = ej.diagrams.NodeConstraints.Default & ~(ej.diagrams.NodeConstraints.Rotate);

In the previous example, rotation is disabled from the default node constraints.

Check operation

You can check any value by using Bitwise & (AND) operator.

if ((node.constraints & (ej.diagrams.NodeConstraints.Rotate)) == (ej.diagrams.NodeConstraints.Rotate));

In the previous example, check whether the rotate constraints are enabled in a node. When node constraints have rotate constraints, the expression returns a rotate constraint.

Constraints in Vue Diagram component

Constraints are used to enable/disable certain behaviors of the Vue Diagram, nodes and connectors. Constraints are provided as flagged enumerations, so that multiple behaviors can be enabled/disabled using Bitwise operators (&, , ~, «, etc.).

To know more about Bitwise operators, refer to Bitwise Operations.

Diagram constraints

Diagram constraints allows you to enable or disable the following behaviors:

The following table displays the list of all diagram constraints.

Constraints Description
None Disable all diagram functionalities.
Bridging Enables or disables Bridging support for connector in diagram.
Undo/redo Enables or disables the Undo/Redo support for the diagram.
UserInteraction Enables or disables user interaction support for the diagram.
ApiUpdate Enables or disables Api update support for the diagram.
PageEditable Enables or disables Page Editable support for the diagram.
Zoom Enables or disables Zoom support for the diagram.
PanX Enables or disables Panning X coordinate support for the diagram.
PanY Enables or disables Panning Y coordinate support for the diagram.
Pan Enables or disables panning both X and Y coordinates support for the diagram.
ZoomTextEdit Enables or disables zooming the text box while editing the text.
Tooltip Enables or disables the tooltip for the diagram.
Virtualization Enables or disables Virtualization support for the diagram.
LineRouting Enables or disables the line routing.
Default Enables or disables all constraints in diagram.

The following example illustrates how to disable page editing using the diagram constraints.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            constraints: DiagramConstraints.Default & ~DiagramConstraints.PageEditable
        }
    }
}

The following example illustrates how to disable page editing using the diagram constraints.

export default {
    name: 'app'
    data() {
        return {
            width: '100%', height: 600,
            constraints: DiagramConstraints.Default | DiagramConstraints.Bridging
        }
    }
}

Multiple behaviors can be added or removed from the default constraints using the Bitwise Operations in the diagram.

export default {
    name: 'app'
    data() {
        return {
            width: '100%', height: 600,
            constraints: DiagramConstraints.Default & ~(DiagramConstraints.PageEditable|DiagramConstraints.Zoom);
        }
    }
}

For more information about diagram constraints, refer to DiagramConstraints.

NOTE

By default, the following constraints are enabled in the diagram,

* Zoom

* ApiUpdate

* PanX

* PanY

* Pan

* Undo/Redo

* PageEditable

* Default

Node constraints

Node constraints allows to enable or disable the following behaviors of node. They are as follows:

Constraints Description
None Disable all node Constraints
Select Enables or disables the node to be selected.
Drag Enables or disables the node to be dragged.
Rotate Enables or disables the node to be rotated.
Shadow Enables or disables the node to display shadow.
PointerEvents Enables or disables the node to provide pointer option.
Delete Enables or disables node to be deleted.
InConnect Enables or disables node to provide in connect option.
OutConnect Enables or disables node to provide out connect option.
AllowDrop Enables node to provide allow to drop option.
Individual Enables node to provide individual resize option
ResizeNorthEast Enable or disable to resize NorthEast side of the node.
ResizeEast Enable or disable to resize East side of the node.
ResizeSouthEast Enable or disable to resize SouthEast side of the node.
ResizeSouth Enable or disable to resize South side of the node.
ResizeSouthWest Enable or disable to resize SouthWest side of the node.
ResizeWest Enable or disable to resize West side of the node.
ResizeNorthWest Enable or disable to resize NorthWest side of the node.
ResizeNorth Enable or disable to resize North side of the node.
AspectRatio Enables the Aspect ratio of the node.
ReadOnly Enables the ReadOnly support for annotation in the node.
HideThumbs Enable to hide all resize thumbs for the node.
Tooltip Enables or disables tooltip for the Nodes.
InheritTooltip Enables or disables inherit tooltip option from the parent object.
Resize Enables or Disables the expansion or compression of a node.
Inherit Enables the node to inherit the interaction option from the parent object.
Expandable Enables node to provide Expandable option
AllowMovingOutsideLane Enables or disables child in parent for the swimLane node
Default Enables all default constraints for the node.

The following example illustrates how to disable rotation using the node constraints.

let nodes = [{
    id: "node1",
    height: 60,
    offsetX: 300,
    offsetY: 80,
    constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
    annotations: [{
        content: "start"
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

The following example shows how to add Shadow constraint to the default constraints of node.

let nodes = [{
    id: "node1",
    height: 60,
    offsetX: 300,
    offsetY: 80,
    constraints: NodeConstraints.Default | NodeConstraints.Shadow,
    annotations: [{
        content: "start"
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

The following code example shows how the tooltip can be enabled for the node.

//Enabled the tooltip constraints for the node.
let nodes = [{
    id: "node1",
    height: 60,
    offsetX: 300,
    offsetY: 80,
    constraints: NodeConstraints.Default | NodeConstraints.Tooltip,
    annotations: [{
        content: "start"
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

Multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

The following code example shows how to remove rotate and resize constraints from node.

 //Removing multiple constraints from default.
let nodes = [{
    id: "node1",
    height: 60,
    offsetX: 300,
    offsetY: 80,
    constraints: NodeConstraints.Default & ~(NodeConstraints.Rotate | NodeConstraints.Resize),
    annotations: [{
        content: "start"
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

Refer sample below

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram, NodeConstraints } from '@syncfusion/ej2-vue-diagrams';
const nodes = [
  {
    id: 'Node1',
    offsetX: 100,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Select disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Select,
  },
  {
    id: 'Node2',
    offsetX: 250,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Rotate disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
  },
  {
    id: 'Node3',
    offsetX: 400,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Resize disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Resize,
  },
  {
    id: 'Node4',
    offsetX: 550,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Drag disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Drag,
  },
  {
    id: 'Node5',
    offsetX: 700,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Tooltip enabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default | NodeConstraints.Tooltip,
    tooltip: { content: 'Node Tooltip', relativeMode: 'Object' },
  },
];

const width = "100%";
const height = "700px";
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent, NodeConstraints } from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 100,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Select disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Select,
  },
  {
    id: 'Node2',
    offsetX: 250,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Rotate disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
  },
  {
    id: 'Node3',
    offsetX: 400,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Resize disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Resize,
  },
  {
    id: 'Node4',
    offsetX: 550,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Drag disabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default & ~NodeConstraints.Drag,
  },
  {
    id: 'Node5',
    offsetX: 700,
    offsetY: 100,
    height: 100,
    width: 100,
    annotations: [{ content: 'Tooltip enabled' }],
    shape: {type: 'Basic', shape: 'Ellipse'},
    constraints: NodeConstraints.Default | NodeConstraints.Tooltip,
    tooltip: { content: 'Node Tooltip', relativeMode: 'Object' },
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information about node constraints, refer to NodeConstraints.

NOTE

By default, the following constraints are enabled for the node,

* Select

* Drag

* Resize

* Rotate

* InConnect

* OutConnect

* PointerEvents

* ResizeNorthEast

* ResizeEast

* ResizeSouthEast

* ResizeSouth

* ResizeSouthWest

* ResizeWest

* ResizeNorthWest

* ResizeNorth

* Inherit

* Expandable

* Individual

* InheritTooltip

* Default

Connector constraints

Connector constraints allow to enable or disable certain behaviors of connectors.

Constraints Description
None Disable all connector Constraints.
Select Enables or disables connector to be selected.
Delete Enables or disables connector to be deleted.
Drag Enables or disables connector to be dragged.
DragSourceEnd Enables connectors source end to be selected.
DragTargetEnd Enables connectors target end to be selected.
DragSegmentThumb Enables control point and end point of every segment in a connector for editing.
Interaction Enables or disables Interaction for the connector.
AllowDrop Enables allow drop support to the connector.
Bridging Enables bridging to the connector.
InheritBridging Enables to inherit bridging option from the parent object.
BridgeObstacle Enables or Disables Bridge Obstacles with overlapping of connectors.
PointerEvents Enables to set the pointer events.
ConnectToNearByNode Enables to connect to the nearest node.
ConnectToNearByPort Enables to connect to the nearest port.
Tooltip Enables or disables tooltip for the connectors.
LineRouting Enables or disables routing to the connector.
InheritLineRouting Enables or disables routing to the connector.
InheritTooltip Enables or disables inherit tooltip option from the parent object
ConnectToNearByElement Enables to connect to the nearest elements.
InheritSegmentThumbShape Enables or disables to inherit the value of segmentThumbShape.
ReadOnly Enables or disables readonly for the connector.
Default Enables all constraints for the connector.

The following code illustrates how to disable selection by using connector constraints.

let connectors = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Select
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
        }
    }
}

The following example shows how to add Bridging constraint to the default constraints of connector.

let connectors = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    constraints: ConnectorConstraints.Default | ConnectorConstraints.Bridging
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
        }
    }
}

NOTE

To visualize connector bridging, we need to inject ConnectorBridgin module.

The following code example shows how the tooltip can be enabled for the connector.

let connectors = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    constraints: ConnectorConstraints.Default | ConnectorConstraints.Tooltip
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
        }
    }
}

The connector constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

//Removing multiple constraints from default.
let connectors = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    constraints: ConnectorConstraints.Default &~ (ConnectorConstraints.DragSourceEnd | ConnectorConstraints.DragTargetEnd)
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
        }
    }
}

Refer sample below

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :connectors='connectors'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram, ConnectorConstraints } from '@syncfusion/ej2-vue-diagrams';
const connectors = [
  {
    id: 'connector1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Select,
    annotations: [{ content: 'Select disabled', alignment: 'After' }],
  },
  {
    id: 'connector2',
    sourcePoint: { x: 250, y: 100 },
    targetPoint: { x: 350, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Drag,
    annotations: [{ content: 'Drag disabled', alignment: 'After' }],
  },
  {
    id: 'connector3',
    sourcePoint: { x: 400, y: 100 },
    targetPoint: { x: 500, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragSourceEnd,
    annotations: [{ content: 'Source end disabled', alignment: 'After' }],
  },
  {
    id: 'connector4',
    sourcePoint: { x: 550, y: 100 },
    targetPoint: { x: 650, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragTargetEnd,
    annotations: [{ content: 'Target end disabled', alignment: 'After' }],
  },
  {
    id: 'connector5',
    sourcePoint: { x: 700, y: 100 },
    targetPoint: { x: 800, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Delete,
    annotations: [{ content: 'Delete disabled', alignment: 'After' }],
  },
];

const width = "100%";
const height = "700px";
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :connectors="connectors"
    ></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent, ConnectorConstraints } from '@syncfusion/ej2-vue-diagrams';
let connectors = [
  {
    id: 'connector1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Select,
    annotations: [{ content: 'Select disabled', alignment: 'After' }],
  },
  {
    id: 'connector2',
    sourcePoint: { x: 250, y: 100 },
    targetPoint: { x: 350, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Drag,
    annotations: [{ content: 'Drag disabled', alignment: 'After' }],
  },
  {
    id: 'connector3',
    sourcePoint: { x: 400, y: 100 },
    targetPoint: { x: 500, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragSourceEnd,
    annotations: [{ content: 'Source end disabled', alignment: 'After' }],
  },
  {
    id: 'connector4',
    sourcePoint: { x: 550, y: 100 },
    targetPoint: { x: 650, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragTargetEnd,
    annotations: [{ content: 'Target end disabled', alignment: 'After' }],
  },
  {
    id: 'connector5',
    sourcePoint: { x: 700, y: 100 },
    targetPoint: { x: 800, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Delete,
    annotations: [{ content: 'Delete disabled', alignment: 'After' }],
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      connectors: connectors,
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information about connector constraints, refer to ConnectorConstraints.

NOTE

By default, the following constraints are enabled for the connector,

* Select

* Delete

* Drag

* Interaction

* ConnectToNearByNode

* ConnectToNearByPort

* ConnectToNearByElement

* BridgeObstacle

* InheritBridging

* PointerEvents

* InheritLineRouting

* InheritTooltip

* InheritSegmentThumbShape

* Default

Port constraints

The constraints property of the Port allows you to enable or disable the following behaviors of port.

Constraints Description
None Disable all port Constraints.
Draw Enables to create the connection when mouse hover on the port.
Drag Enables or disables port dragging
InConnect Enables or disables to connect only the target end of connector.
OutConnect Enables or disables to connect only the source end of connector.
ToolTip Enables or disables the Tooltip for the ports.
InheritTooltip Enables or disables the Tooltip for the ports.
Default Enables all constraints for the port.

The following code illustrates how to disable creating connections with a port.

let nodes = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    ports: [{
        constraints: PortConstraints.None
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

The following code example shows how to modify the port constraints to accept target connection alone.

let nodes = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    ports: [{
         //Enable to create target connection alone.
        constraints: PortConstraints.InConnect
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

The port constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

let nodes = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    ports: [{
        //Enable to draw connector from port also accepts both in and out connections.
        constraints: PortConstraints.Default | PortConstraints.Draw
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

Refer sample below

<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
    ></ejs-diagram>
  </div>
</template>
<script setup>
import {
  DiagramComponent as EjsDiagram,
  PortConstraints,
  PortVisibility,
} from "@syncfusion/ej2-vue-diagrams";
const nodes = [
  {
    id: "Node1",
    offsetX: 200,
    offsetY: 200,
    height: 200,
    width: 300,
    annotations: [
      { content: "tooltip enabled", offset: { x: 0.5, y: 0.1 } },
      { content: "draw enabled", offset: { x: 0.2, y: 0.5 } },
      { content: "drg enabled", offset: { x: 0.8, y: 0.5 } },
      { content: "InConnect disabled", offset: { x: 0.2, y: 0.9 } },
      { content: "OutConnect disabled", offset: { x: 0.8, y: 0.9 } },
    ],
    ports: [
      {
        id: "left",
        offset: { x: 0, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Draw,
      },
      {
        id: "right",
        offset: { x: 1, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Drag,
      },
      {
        id: "top",
        offset: { x: 0.5, y: 0 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.ToolTip,
        tooltip: { content: "Port tooltip" },
      },
      {
        id: "bottomLeft",
        offset: { x: 0.2, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.InConnect,
      },
      {
        id: "bottomRight",
        offset: { x: 0.8, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.OutConnect,
      },
    ],
  },
];

const width = "100%";
const height = "700px";
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
    ></ejs-diagram>
  </div>
</template>
<script>
import {
  DiagramComponent,
  PortConstraints,
  PortVisibility,
} from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 200,
    width: 300,
    annotations: [
      { content: 'tooltip enabled', offset: { x: 0.5, y: 0.1 } },
      { content: 'draw enabled', offset: { x: 0.2, y: 0.5 } },
      { content: 'drg enabled', offset: { x: 0.8, y: 0.5 } },
      { content: 'InConnect disabled', offset: { x: 0.2, y: 0.9 } },
      { content: 'OutConnect disabled', offset: { x: 0.8, y: 0.9 } },
    ],
    ports: [
      {
        id: 'left',
        offset: { x: 0, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Draw,
      },
      {
        id: 'right',
        offset: { x: 1, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Drag,
      },
      {
        id: 'top',
        offset: { x: 0.5, y: 0 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.ToolTip,
        tooltip: { content: 'Port tooltip' },
      },
      {
        id: 'bottomLeft',
        offset: { x: 0.2, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.InConnect,
      },
      {
        id: 'bottomRight',
        offset: { x: 0.8, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.OutConnect,
      },
    ],
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information about port constraints, refer to PortConstraints.

NOTE

By default, the following constraints are enabled for the port,

* InConnect

* OutConnect

Annotation constraints

The constraints property of the Annotations allows you to enable or disable certain behaviors of annotation.

Constraints Description
ReadOnly Enables or disables the ReadOnly Constraints,
InheritReadOnly Enables or disables to inherit the ReadOnly option from the parent object.
Select Enables or Disable select support for the annotation
Drag Enables or Disable drag support for the annotation
Resize Enables or Disable resize support for the annotation
Rotate Enables or Disable rotate support for the annotation
Interaction Enables interaction of annotation
None Disables all constraints for the annotation.

The read-only mode for the annotation is enabled by settings ReadOnly constraints to the annotation.

The following code illustrates how to enable read-only mode for the annotations.

let nodes = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    annotations: [{
        id: 'anotation_1',
        content: 'annotation',
        constraints: AnnotationConstraints.ReadOnly,
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

Interactions such as select, drag, resize, and rotate can be enabled for the annotation as shown below.

let nodes = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    annotations: [{
        id: 'anotation_1',
        content: 'annotation',
        constraints: AnnotationConstraints.Select | AnnotationConstraints.Drag | AnnotationConstraints.Select | AnnotationConstraints.Resize | AnnotationConstraints.Rotate,
    }]
}]
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            nodes: nodes,
        }
    }
}

Refer sample below

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes'></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram, AnnotationConstraints,
} from '@syncfusion/ej2-vue-diagrams';
const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    width: 300,
    height: 200,
    annotations: [
      {
        content: 'Interaction enabled',
        offset: { x: 0.5, y: 0.1 },
        constraints: AnnotationConstraints.Interaction,
      },
      {
        content: 'ReadOnly enabled',
        offset: { x: 0.2, y: 0.5 },
        constraints: AnnotationConstraints.ReadOnly,
      },
      {
        content: 'Select and drag enabled',
        offset: { x: 0.8, y: 0.5 },
        constraints: AnnotationConstraints.Select | AnnotationConstraints.Drag,
      },
      {
        content: 'Select and rotate enabled',
        offset: { x: 0.5, y: 0.9 },
        constraints:
          AnnotationConstraints.Select | AnnotationConstraints.Rotate,
      },
    ],
  },
];

const width = "100%";
const height = "700px";
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
    ></ejs-diagram>
  </div>
</template>
<script>
import {
  DiagramComponent,
  AnnotationConstraints,
} from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    width: 300,
    height: 200,
    annotations: [
      {
        content: 'Interaction enabled',
        offset: { x: 0.5, y: 0.1 },
        constraints: AnnotationConstraints.Interaction,
      },
      {
        content: 'ReadOnly enabled',
        offset: { x: 0.2, y: 0.5 },
        constraints: AnnotationConstraints.ReadOnly,
      },
      {
        content: 'Select and drag enabled',
        offset: { x: 0.8, y: 0.5 },
        constraints: AnnotationConstraints.Select | AnnotationConstraints.Drag,
      },
      {
        content: 'Select and rotate enabled',
        offset: { x: 0.5, y: 0.9 },
        constraints:
          AnnotationConstraints.Select | AnnotationConstraints.Rotate,
      },
    ],
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more details about annotation constraints, refer to AnnotationConstraints.

Selector constraints

Selector visually represents the selected elements with certain editable thumbs. The visibility of the thumbs can be controlled with selector constraints. The part of selector is categorized as follows:

Constraints Description
None Hides all the selector elements.
ConnectorSourceThumb Shows or hides the source thumb of the connector.
ConnectorTargetThumb Shows or hides the target thumb of the connector.
ResizeSouthEast Shows or hides the bottom right resize handle of the selector.
ResizeSouthWest Shows or hides the bottom left resize handle of the selector.
ResizeNorthEast Shows or hides the top right resize handle of the selector.
ResizeNorthWest Shows or hides the top left resize handle of the selector.
ResizeEast Shows or hides the middle right resize handle of the selector.
ResizeWest Shows or hides the middle left resize handle of the selector.
ResizeSouth Shows or hides the bottom center resize handle of the selector.
ResizeNorth Shows or hides the top center resize handle of the selector.
Rotate Shows or hides the rotate handle of the selector.
UserHandle Shows or hides the user handles of the selector.
ToolTip Shows or hides the default tooltip for the drag, resize, and rotate operation of nodes and connectors.
ResizeAll Shows or hides all resize handles of the selector.
All Shows all handles of the selector.

The following code illustrates how to hide rotator.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            selectedItems: {
                constraints: SelectorConstraints.All & ~SelectorConstraints.Rotate
            }
        }
    }
}

The following code demonstrates how to hide the default tooltip during the drag, resize, and rotate operations on nodes:

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            selectedItems: {
                constraints: SelectorConstraints.All & ~SelectorConstraints.ToolTip
            }
        }
    }
}

The following code example shows how to disable the user handle functionality for the selected item.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            selectedItems: {
                constraints: SelectorConstraints.All & ~SelectorConstraints.UserHandle
            }
        }
    }
}

Refer sample below

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :selectedItems="selectedItems"></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram, SelectorConstraints } from '@syncfusion/ej2-vue-diagrams';
const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [
      { content: 'Resize handle disabled in selector constraints' },
    ],
  },
];

const width = "100%";
const height = "700px";
const selectedItems = {
        constraints:  SelectorConstraints.All & ~SelectorConstraints.ResizeAll
    }
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :selectedItems="selectedItems"
    ></ejs-diagram>
  </div>
</template>
<script>
import {
  DiagramComponent,
  SelectorConstraints,
} from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [
      { content: 'Resize handle disabled in selector constraints' },
    ],
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
      selectedItems: {
        constraints:  SelectorConstraints.All & ~SelectorConstraints.ResizeAll
    }
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information about selector constraints, refer to SelectorConstraints.

NOTE

By default, the following constraints are enabled for the selected items,

* Rotate

* UserHandel

* ResizeAll

* All

* ToolTip

Snap constraints

Snap constraints control the visibility of gridlines and enable/disable snapping.

The following list of snapping constraints are used to enable or disable certain features of snapping.

Constraints Description
None Disable snapping for the nodes/connectors in diagram.
ShowHorizontalLines Displays only the horizontal gridlines in diagram.
ShowVerticalLines Displays only the Vertical gridlines in diagram.
ShowLines Display both Horizontal and Vertical gridlines.
SnapToHorizontalLines Enables the object to snap only with horizontal gridlines.
SnapToVerticalLines Enables the object to snap only with Vertical gridlines.
SnapToLines Enables the object to snap with both horizontal and Vertical gridlines.
SnapToObject Enables the object to snap with the other objects in the diagram.
All Shows gridlines and enables snapping.

The following code illustrates how to show only horizontal gridlines.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            snapSettings: {
                constraints: SnapConstraints.ShowHorizontalLines
            }
        }
    }
}

The snap constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            snapSettings: {
                constraints: SnapConstraints.ShowHorizontalLines | SnapConstraints.ShowVerticalLines
            }
        }
    }
}

Refer sample below

<template>
  <div id="app">
    <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :snapSettings="snapSettings"></ejs-diagram>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, SnapConstraints, Snapping } from '@syncfusion/ej2-vue-diagrams';
const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [{ content: 'Node 1' }],
  },
  {
    id: 'Node2',
    offsetX: 400,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [{ content: 'Node 2' }],
  },
];

const width = "100%";
const height = "700px";
const snapSettings = {
  constraints: SnapConstraints.ShowHorizontalLines | SnapConstraints.SnapToObject,
}
provide('diagram', [Snapping])
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram id="diagram" ref="diagram" :width="width" :height="height" :nodes="nodes"
      :snapSettings="snapSettings"></ejs-diagram>
  </div>
</template>
<script>
import { DiagramComponent, SnapConstraints, Snapping } from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [{ content: 'Node 1' }],
  },
  {
    id: 'Node2',
    offsetX: 400,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [{ content: 'Node 2' }],
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
      snapSettings: {
        constraints: SnapConstraints.ShowHorizontalLines | SnapConstraints.SnapToObject,
      },
    };
  },
  provide: {
    diagram: [Snapping]
  }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information about snap constraints, refer to SnapConstraints.

NOTE

By default, the following constraints are enabled for the snap functionality in the diagram,

* ShowLines

* ShowVerticalLines

* ShowHorizontalLines

* SnapToLines

* SnapToHorizontalLines

* SnapToVerticalLines

* SnapToObject

* All

Boundary constraints

Boundary constraints defines a boundary for the diagram inside which the interaction should be done.

The following list of constraints are used to enable or disable certain features of boundary interactions of the diagram.

Constraints Description
Infinity Allow the interactions to take place at the infinite height and width.
Diagram Allow the interactions to take place around the diagram height and width.
Page Allow the interactions to take place around the page height and width.

The following code illustrates how to limit the interaction done inside a diagram within a page.

export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            pageSettings: {
                boundaryConstraints: 'Page'
            }
        }
    }
}

Refer sample below

<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :nodes='nodes' :snapSettings="snapSettings"></ejs-diagram>
    </div>
</template>
<script setup>
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
const nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [{ content: 'Node interactions restricted within page'}],
  },
];

const width = "100%";
const height = "700px";
const pageSettings ={
    // Boundary set as page
    boundaryConstraints: 'Page',
    width: 500,
    height: 500,
    showPageBreaks: true,
    background: { color: 'grey' },
  }
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram
      id="diagram"
      ref="diagram"
      :width="width"
      :height="height"
      :nodes="nodes"
      :pageSettings="pageSettings"
    ></ejs-diagram>
  </div>
</template>
<script>
import {
  DiagramComponent,
} from '@syncfusion/ej2-vue-diagrams';
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    height: 100,
    width: 100,
    annotations: [{ content: 'Node interactions restricted within page'  }],
  },
];

export default {
  name: 'App',
  components: {
    'ejs-diagram': DiagramComponent,
  },
  data() {
    return {
      width: '100%',
      height: '700px',
      nodes: nodes,
      pageSettings: {
    // Boundary set as page
    boundaryConstraints: 'Page',
    width: 500,
    height: 500,
    showPageBreaks: true,
    background: { color: 'grey' },
  },
    };
  },
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

For more information about selector constraints, refer to BoundaryConstraints.

Inherit behaviors

Some of the behaviors can be defined through both the specific object (node/connector) and diagram. When the behaviors are contradictorily defined through both, the actual behavior is set through inherit options.

The following code example illustrates how to inherit the line bridging behavior from the diagram model.

Diagram.Inject(ConnectorBridging);
let connectors[] = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    constraints: ConnectorConstraints.Default & ConnectorConstraints.InheritBridging
},
{
    id: 'connector2',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 200
    },
    targetPoint: {
        x: 200,
        y: 100
    },
    constraints: ConnectorConstraints.Default & ConnectorConstraints.InheritBridging
}];
export default {
    name: 'app'
    data() {
        return {
            width: "100%",
            height: "350px",
            connectors: connectors,
            constraints: DiagramConstraints.Default | DiagramConstraints.Bridging
        }
    }
}

Bitwise operations

Bitwise operations are used to manipulate the flagged enumerations enum.In this section, Bitwise operations are shown by using the node constraints. The same is applicable when working connector constraints, or port constraints.

Add operation

You can add or enable multiple values at a time by using Bitwise ‘ ’ (OR) operator.

The following code demonstrates how to add tooltip constraints to the default node constraints, thereby enabling tooltip functionality for the node:

node.constraints = NodeConstraints.Select | NodeConstraints.Rotate;

In the previous example, you can perform basic interactions with the node while also enabling tooltip functionality.

Remove Operation

You can remove or disable values by using Bitwise ‘&~’ (XOR) operator.

node.constraints = node.constraints & ~(NodeConstraints.Rotate);

In the previous example, rotation is disabled but other constraints are enabled.

Check Operation

You can check any value by using Bitwise ‘&’ (AND) operator.

if ((node.constraints & (NodeConstraints.Rotate)) == (NodeConstraints.Rotate));

In the previous example, check whether the rotate constraints are enabled in a node. When node constraints have rotate constraints, the expression returns a rotate constraint.

Constraints in React Diagram Component

Constraints enable or disable specific behaviors of diagrams, nodes, and connectors. These constraints are implemented as flagged enumerations, allowing multiple behaviors to be controlled simultaneously using Bitwise operators (&, |, ~, <<, etc.).

To know more about Bitwise operators, refer to Bitwise Operations.

Diagram Constraints

Diagram constraints control the overall behavior and functionality of the diagram canvas.

The following table displays the list of all diagram constraints.

Constraints Description
None Disables all diagram functionalities.
Bridging Enables bridging support for connectors in the diagram.
Undo/redo Enables undo and redo functionality for diagram operations.
UserInteraction Enables user interaction capabilities for the diagram.
ApiUpdate Enables programmatic updates through API calls.
PageEditable Enables editing within the page boundaries.
Zoom Enables zooming functionality for the diagram.
PanX Enables horizontal panning of the diagram.
PanY Enables vertical panning of the diagram.
Pan Enables both horizontal and vertical panning.
ZoomTextEdit Enables text box zooming during text editing operations.
Tooltip Enables tooltip display for diagram elements.
Virtualization Enables virtualization support for large diagrams.
LineRouting Enables automatic line routing for connectors.
Default Enables all default constraints for the diagram.

The following example illustrates how to disable page editing using the diagram constraints.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      constraints={
        DiagramConstraints.Default & ~DiagramConstraints.PageEditable
      }
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

The following example shows how to enable Bridging constraint to the default constraints of diagram.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      constraints={
        DiagramConstraints.Default | DiagramConstraints.Bridging
      }
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Multiple behaviors can be added or removed from the default constraints using the Bitwise Operations in the diagram.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      constraints={
       DiagramConstraints.Default & ~(DiagramConstraints.PageEditable|DiagramConstraints.Zoom)
      }
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

For more information about diagram constraints, refer to DiagramConstraints.

NOTE

By default, the following constraints are enabled in the diagram,

* Zoom

* ApiUpdate

* PanX

* PanY

* Pan

* Undo/Redo

* PageEditable

* Default

Node Constraints

Node constraints control the behavior and interactions available for individual nodes within the diagram.

Constraints Description
None Disables all node constraints.
Select Enables node selection capability.
Drag Enables node dragging functionality.
Rotate Enables node rotation capability.
Shadow Enables shadow display for the node.
PointerEvents Enables pointer event handling for the node.
Delete Enables node deletion capability.
InConnect Enables incoming connections to the node.
OutConnect Enables outgoing connections from the node.
AllowDrop Enables drop operations on the node.
Individual Enables individual resize handles for the node.
ResizeNorthEast Enables resizing from the northeast corner.
ResizeEast Enables resizing from the east side.
ResizeSouthEast Enables resizing from the southeast corner.
ResizeSouth Enables resizing from the south side.
ResizeSouthWest Enables resizing from the southwest corner.
ResizeWest Enables resizing from the west side.
ResizeNorthWest Enables resizing from the northwest corner.
ResizeNorth Enables resizing from the north side.
AspectRatio Maintains aspect ratio during resize operations.
ReadOnly Enables read-only mode for node annotations.
HideThumbs Hides all resize thumbs for the node.
Tooltip Enables tooltip display for the node.
InheritTooltip Inherits tooltip settings from parent objects.
Resize Enables overall resize functionality for the node.
Inherit Inherits interaction settings from parent objects.
Expandable Enables expand/collapse functionality for the node.
AllowMovingOutsideLane Allows movement outside swim lane boundaries.
Default Enables all default constraints for the node.

The following example demonstrates how to disable rotation using node constraints:

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
  },
];
function App() {
  return (
    <DiagramComponent id="container" width={700} height={600} nodes={nodes} />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

The following example shows how to add shadow constraint to the default node constraints:

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    constraints: NodeConstraints.Default | NodeConstraints.Shadow,
  },
];
function App() {
  return (
    <DiagramComponent id="container" width={700} height={600} nodes={nodes} />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

The following code example shows how to enable tooltip for a node:

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    constraints: NodeConstraints.Default | NodeConstraints.Tooltip,
  },
];
function App() {
  return (
    <DiagramComponent id="container" width={700} height={600} nodes={nodes} />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Multiple behaviors can be added or removed from the default constraints using Bitwise Operations.

The following code example shows how to remove rotate and resize constraints from node.

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    constraints: NodeConstraints.Default &~ (NodeConstraints.Rotate | NodeConstraints.Resize),
  },
];
function App() {
  return (
    <DiagramComponent id="container" width={700} height={600} nodes={nodes} />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  NodeConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let node = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 100,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Select disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Select,
  },
  {
    id: 'node2',
    // Position of the node
    offsetX: 250,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Rotate disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
  },
  {
    id: 'node3',
    // Position of the node
    offsetX: 400,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Resize disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Resize,
  },
  {
    id: 'node4',
    // Position of the node
    offsetX: 550,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Drag disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Drag,
  },
  {
    id: 'node5',
    // Position of the node
    offsetX: 700,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Tooltip enabled' }],
    constraints: NodeConstraints.Default | NodeConstraints.Tooltip,
    tooltip: { content: 'Node Tooltip', relativeMode: 'Object' },
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={node}
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.shape = { shape: 'Ellipse' };
        node.style.fill = '#6BA5D7';
        node.style.strokeColor = 'white';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  NodeModel,
  NodeConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let node: NodeModel[] = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 100,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Select disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Select,
  },
  {
    id: 'node2',
    // Position of the node
    offsetX: 250,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Rotate disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
  },
  {
    id: 'node3',
    // Position of the node
    offsetX: 400,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Resize disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Resize,
  },
  {
    id: 'node4',
    // Position of the node
    offsetX: 550,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Drag disabled' }],
    constraints: NodeConstraints.Default & ~NodeConstraints.Drag,
  },
  {
    id: 'node5',
    // Position of the node
    offsetX: 700,
    offsetY: 100,
    style: {
      fill: '#6BA5D7',
      strokeColor: 'white',
    },
    annotations: [{ content: 'Tooltip enabled' }],
    constraints: NodeConstraints.Default | NodeConstraints.Tooltip,
    tooltip: { content: 'Node Tooltip', relativeMode: 'Object' },
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={node}
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.shape = { shape: 'Ellipse' };
        node.style.fill = '#6BA5D7';
        node.style.strokeColor = 'white';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information about node constraints, refer to NodeConstraints.

NOTE

By default, the following constraints are enabled for the node,

* Select

* Drag

* Resize

* Rotate

* InConnect

* OutConnect

* PointerEvents

* ResizeNorthEast

* ResizeEast

* ResizeSouthEast

* ResizeSouth

* ResizeSouthWest

* ResizeWest

* ResizeNorthWest

* ResizeNorth

* Inherit

* Expandable

* Individual

* InheritTooltip

* Default

Connector Constraints

Connector constraints control the behavior and interactions available for connectors within the diagram.

Constraints Description
None Disables all connector constraints.
Select Enables connector selection capability.
Delete Enables connector deletion capability.
Drag Enables connector dragging functionality.
DragSourceEnd Enables dragging of the connector’s source endpoint.
DragTargetEnd Enables dragging of the connector’s target endpoint.
DragSegmentThumb Enables dragging of segment control points.
Interaction Enables general interaction capabilities for the connector.
AllowDrop Enables drop operations on the connector.
Bridging Enables bridging functionality for the connector.
InheritBridging Inherits bridging settings from parent objects.
BridgeObstacle Enables the connector to act as a bridge obstacle.
PointerEvents Enables pointer event handling for the connector.
ConnectToNearByNode Enables automatic connection to nearby nodes.
ConnectToNearByPort Enables automatic connection to nearby ports.
Tooltip Enables tooltip display for the connector.
LineRouting Enables line routing functionality for the connector.
InheritLineRouting Inherits line routing settings from parent objects.
InheritTooltip Inherits tooltip settings from parent objects.
ConnectToNearByElement Enables automatic connection to nearby elements.
InheritSegmentThumbShape Inherits segment thumb shape from parent objects.
ReadOnly Enables read-only mode for the connector.
Default Enables all default constraints for the connector.

The following code demonstrates how to disable selection using connector constraints:

let connectors: ConnectorModel[] = [{
            id: 'connector1',
            type: 'Straight',
            sourcePoint: {
                x: 100,
                y: 100
            },
            targetPoint: {
                x: 200,
                y: 200
            },
            constraints: {
                ConnectorConstraints.Default & ~ConnectorConstraints.Select
            }];
function App() {
  return (
    <DiagramComponent id="container"
    width={700}
    height={600}
    connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

The following example shows how to add bridging constraint to the default connector constraints:

let connectors: ConnectorModel[] = [{
            id: 'connector1',
            type: 'Straight',
            sourcePoint: {
                x: 100,
                y: 100
            },
            targetPoint: {
                x: 200,
                y: 200
            },
            constraints: {
                ConnectorConstraints.Default | ConnectorConstraints.Bridging
            }];
function App() {
  return (
    <DiagramComponent id="container"
    width={700}
    height={600}
    connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

NOTE

To visualize connector bridging, inject the ConnectorBridging module.

The following example shows how to enable tooltip for connectors:

let connectors: ConnectorModel[] = [{
            id: 'connector1',
            type: 'Straight',
            sourcePoint: {
                x: 100,
                y: 100
            },
            targetPoint: {
                x: 200,
                y: 200
            },
            constraints: {
                ConnectorConstraints.Default | ConnectorConstraints.Tooltip
            }];
function App() {
  return (
    <DiagramComponent id="container"
    width={700}
    height={600}
    connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

The connector constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

//Removing multiple constraints from default.
let connectors: ConnectorModel[] = [{
            id: 'connector1',
            type: 'Straight',
            sourcePoint: {
                x: 100,
                y: 100
            },
            targetPoint: {
                x: 200,
                y: 200
            },
            constraints: {
                ConnectorConstraints.Default &~ (ConnectorConstraints.DragSourceEnd|ConnectorConstraints.DragTargetEnd)
            }];
function App() {
  return (
    <DiagramComponent id="container"
    width={700}
    height={600}
    connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  ConnectorConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let connectors = [
  {
    id: 'connector1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Select,
    annotations: [{ content: 'Select disabled', alignment: 'After' }],
  },
  {
    id: 'connector2',
    sourcePoint: { x: 250, y: 100 },
    targetPoint: { x: 350, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Drag,
    annotations: [{ content: 'Drag disabled', alignment: 'After' }],
  },
  {
    id: 'connector3',
    sourcePoint: { x: 400, y: 100 },
    targetPoint: { x: 500, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragSourceEnd,
    annotations: [{ content: 'Source end disabled', alignment: 'After' }],
  },
  {
    id: 'connector4',
    sourcePoint: { x: 550, y: 100 },
    targetPoint: { x: 650, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragTargetEnd,
    annotations: [{ content: 'Target end disabled', alignment: 'After' }],
  },
  {
    id: 'connector5',
    sourcePoint: { x: 700, y: 100 },
    targetPoint: { x: 800, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Delete,
    annotations: [{ content: 'Delete disabled', alignment: 'After' }],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  ConnectorConstraints,
  ConnectorModel
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let connectors: ConnectorModel[] = [
  {
    id: 'connector1',
    sourcePoint: { x: 100, y: 100 },
    targetPoint: { x: 200, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Select,
    annotations: [{ content: 'Select disabled', alignment: 'After' }],
  },
  {
    id: 'connector2',
    sourcePoint: { x: 250, y: 100 },
    targetPoint: { x: 350, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Drag,
    annotations: [{ content: 'Drag disabled', alignment: 'After' }],
  },
  {
    id: 'connector3',
    sourcePoint: { x: 400, y: 100 },
    targetPoint: { x: 500, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragSourceEnd,
    annotations: [{ content: 'Source end disabled', alignment: 'After' }],
  },
  {
    id: 'connector4',
    sourcePoint: { x: 550, y: 100 },
    targetPoint: { x: 650, y: 200 },
    type: 'Orthogonal',
    constraints:
      ConnectorConstraints.Default & ~ConnectorConstraints.DragTargetEnd,
    annotations: [{ content: 'Target end disabled', alignment: 'After' }],
  },
  {
    id: 'connector5',
    sourcePoint: { x: 700, y: 100 },
    targetPoint: { x: 800, y: 200 },
    type: 'Orthogonal',
    constraints: ConnectorConstraints.Default & ~ConnectorConstraints.Delete,
    annotations: [{ content: 'Delete disabled', alignment: 'After' }],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      connectors={connectors}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information about connector constraints, refer to ConnectorConstraints.

NOTE

By default, the following constraints are enabled for the connector,

* Select

* Delete

* Drag

* Interaction

* ConnectToNearByNode

* ConnectToNearByPort

* ConnectToNearByElement

* BridgeObstacle

* InheritBridging

* PointerEvents

* InheritLineRouting

* InheritTooltip

* InheritSegmentThumbShape

* Default

Port Constraints

Port constraints control the behavior and connection capabilities of ports attached to nodes.

Constraints Description
None Disables all port constraints.
Draw Enables connection creation when hovering over the port.
Drag Enables port dragging functionality.
InConnect Enables incoming connections to the port only.
OutConnect Enables outgoing connections from the port only.
ToolTip Enables tooltip display for the port.
InheritTooltip Inherits tooltip settings from parent objects.
Default Enables all default constraints for the port.

The following code illustrates how to disable creating connections with a port.

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    ports: [
      {
        constraints: PortConstraints.None,
      },
    ],
  },
];

The following code example shows how to configure port constraints to accept only incoming connections:

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    ports: [
      {   //Enable to create target connection alone.
          constraints: PortConstraints.InConnect
      },
    ],
  },
];

The port constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    ports: [
        {   //Enable to draw connector from port also accepts both in and out connections.
             constraints: PortConstraints.Default | PortConstraints.Draw;
        }
    ]
  },
];

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  PortVisibility,
  PortConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let node = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 200,
    offsetY: 200,
    annotations: [
      { content: 'tooltip enabled', offset: { x: 0.5, y: 0.1 } },
      { content: 'draw enabled', offset: { x: 0.2, y: 0.5 } },
      { content: 'drag enabled', offset: { x: 0.8, y: 0.5 } },
      { content: 'InConnect disabled', offset: { x: 0.2, y: 0.9 } },
      { content: 'OutConnect disabled', offset: { x: 0.8, y: 0.9 } },
    ],
    ports: [
      {
        id: 'left',
        offset: { x: 0, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Draw,
      },
      {
        id: 'right',
        offset: { x: 1, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Drag,
      },
      {
        id: 'top',
        offset: { x: 0.5, y: 0 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.ToolTip,
        tooltip: { content: 'Port tooltip' },
      },
      {
        id: 'bottomLeft',
        offset: { x: 0.2, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.InConnect,
      },
      {
        id: 'bottomRight',
        offset: { x: 0.8, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.OutConnect,
      },
    ],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={node}
      getNodeDefaults={(node) => {
        node.height = 200;
        node.width = 300;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  NodeModel,
  PortVisibility,
  PortConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let node: NodeModel[] = [
  {
    id: 'node1',
    // Position of the node
    offsetX: 200,
    offsetY: 200,
    annotations: [
      { content: 'tooltip enabled', offset: { x: 0.5, y: 0.1 } },
      { content: 'draw enabled', offset: { x: 0.2, y: 0.5 } },
      { content: 'drag enabled', offset: { x: 0.8, y: 0.5 } },
      { content: 'InConnect disabled', offset: { x: 0.2, y: 0.9 } },
      { content: 'OutConnect disabled', offset: { x: 0.8, y: 0.9 } },
    ],
    ports: [
      {
        id: 'left',
        offset: { x: 0, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Draw,
      },
      {
        id: 'right',
        offset: { x: 1, y: 0.5 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.Drag,
      },
      {
        id: 'top',
        offset: { x: 0.5, y: 0 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default | PortConstraints.ToolTip,
        tooltip: { content: 'Port tooltip' },
      },
      {
        id: 'bottomLeft',
        offset: { x: 0.2, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.InConnect,
      },
      {
        id: 'bottomRight',
        offset: { x: 0.8, y: 1 },
        visibility: PortVisibility.Visible,
        constraints: PortConstraints.Default & ~PortConstraints.OutConnect,
      },
    ],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={node}
      getNodeDefaults={(node) => {
        node.height = 200;
        node.width = 300;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information about port constraints, refer to PortConstraints.

NOTE

By default, the following constraints are enabled for the port,

* InConnect

* OutConnect

Annotation Constraints

Annotation constraints control the behavior and edit ability of text annotations on nodes and connectors.

Constraints Description
ReadOnly Enables read-only mode for the annotation.
InheritReadOnly Inherits read-only settings from parent objects.
Select Enables selection capability for the annotation.
Drag Enables dragging functionality for the annotation.
Resize Enables resize capability for the annotation.
Rotate Enables rotation capability for the annotation.
Interaction Enables general interaction capabilities for the annotation.
None Disables all constraints for the annotation.

The read-only mode for the annotation is enabled by settings ReadOnly constraints to the annotation.

The following code illustrates how to enable read-only mode for the annotations.

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "anotation_1",
        content: "annotation",
        constraints: AnnotationConstraints.ReadOnly,
      },
    ],
  },
];
function App() {
  return (
    <DiagramComponent id="container" width={700} height={600} nodes={nodes} />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Interactions such as select, drag, resize, and rotate can be enabled for the annotation as shown below.

let nodes: NodeModel[] = [
  {
    id: "node",
    offsetX: 100,
    offsetY: 100,
    annotations: [
      {
        id: "anotation_1",
        content: "annotation",
        constraints: AnnotationConstraints.Select | AnnotationConstraints.Drag | AnnotationConstraints.Resize |
                AnnotationConstraints.Rotate,
      },
    ],
  },
];
function App() {
  return (
    <DiagramComponent id="container" width={700} height={600} nodes={nodes} />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  AnnotationConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      {
        content: 'Interaction enabled',
        offset: { x: 0.5, y: 0.1 },
        constraints: AnnotationConstraints.Interaction,
      },
      {
        content: 'ReadOnly enabled',
        offset: { x: 0.2, y: 0.5 },
        constraints: AnnotationConstraints.ReadOnly,
      },
      {
        content: 'Select and drag enabled',
        offset: { x: 0.8, y: 0.5 },
        constraints: AnnotationConstraints.Select | AnnotationConstraints.Drag,
      },
      {
        content: 'Select and rotate enabled',
        offset: { x: 0.5, y: 0.9 },
        constraints:
          AnnotationConstraints.Select | AnnotationConstraints.Rotate,
      },
    ],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      getNodeDefaults={(node) => {
        node.height = 200;
        node.width = 300;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  NodeModel,
  AnnotationConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes: NodeModel[] = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      {
        content: 'Interaction enabled',
        offset: { x: 0.5, y: 0.1 },
        constraints: AnnotationConstraints.Interaction,
      },
      {
        content: 'ReadOnly enabled',
        offset: { x: 0.2, y: 0.5 },
        constraints: AnnotationConstraints.ReadOnly,
      },
      {
        content: 'Select and drag enabled',
        offset: { x: 0.8, y: 0.5 },
        constraints: AnnotationConstraints.Select | AnnotationConstraints.Drag,
      },
      {
        content: 'Select and rotate enabled',
        offset: { x: 0.5, y: 0.9 },
        constraints:
          AnnotationConstraints.Select | AnnotationConstraints.Rotate,
      },
    ],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      getNodeDefaults={(node) => {
        node.height = 200;
        node.width = 300;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more details about annotation constraints, refer to AnnotationConstraints.

Selector Constraints

Selector constraints control the visibility and behavior of selection handles and thumbs that appear when elements are selected.

Constraints Description
None Hides all selector elements.
ConnectorSourceThumb Shows or hides the connector’s source thumb.
ConnectorTargetThumb Shows or hides the connector’s target thumb.
ResizeSouthEast Shows or hides the bottom-right resize handle.
ResizeSouthWest Shows or hides the bottom-left resize handle.
ResizeNorthEast Shows or hides the top-right resize handle.
ResizeNorthWest Shows or hides the top-left resize handle.
ResizeEast Shows or hides the middle-right resize handle.
ResizeWest Shows or hides the middle-left resize handle.
ResizeSouth Shows or hides the bottom-center resize handle.
ResizeNorth Shows or hides the top-center resize handle.
Rotate Shows or hides the rotation handle.
UserHandle Shows or hides custom user handles.
ToolTip Shows or hides tooltips during drag, resize, and rotate operations.
ResizeAll Shows or hides all resize handles.
All Shows all available handles.

The following code illustrates how to hide rotator.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      selectedItems={{
        constraints: SelectorConstraints.All & ~SelectorConstraints.Rotate,
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

The following code demonstrates how to hide the default tooltip during the drag, resize, and rotate operations on nodes:

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      selectedItems={{
        constraints: SelectorConstraints.All & ~SelectorConstraints.ToolTip,
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

The following code example shows how to disable the userhandle functionality for the selected item.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      selectedItems={{
        constraints: SelectorConstraints.All & ~SelectorConstraints.UserHandle,
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  SelectorConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      { content: 'Resize handle disabled in selector constraints' },
    ],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      selectedItems=
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  NodeModel,
  SelectorConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes: NodeModel[] = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [
      { content: 'Resize handle disabled in selector constraints' },
    ],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      selectedItems=
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information about selector constraints, refer to SelectorConstraints.

NOTE

By default, the following constraints are enabled for the selected items:

* Rotate

* UserHandle

* ResizeAll

* All

* ToolTip

Snap Constraints

Snap constraints control the visibility of gridlines and enable or disable snapping functionality for precise element positioning.

The following list of snapping constraints are used to enable or disable certain features of snapping.

Constraints Description
None Disables snapping for all diagram elements.
ShowHorizontalLines Displays horizontal gridlines in the diagram.
ShowVerticalLines Displays vertical gridlines in the diagram.
ShowLines Displays both horizontal and vertical gridlines.
SnapToHorizontalLines Enables snapping to horizontal gridlines only.
SnapToVerticalLines Enables snapping to vertical gridlines only.
SnapToLines Enables snapping to both horizontal and vertical gridlines.
SnapToObject Enables snapping to other objects in the diagram.
All Shows gridlines and enables all snapping functionality.

The following code demonstrates how to show only horizontal gridlines:

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      snapSettings={{
        constraints: SnapConstraints.ShowHorizontalLines,
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

The snap constraints are provided as flagged enumerations, so that multiple behaviors can be added or removed from the default constraints using the Bitwise Operations.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      snapSettings={{
        constraints: SnapConstraints.ShowHorizontalLines | SnapConstraints.ShowVerticalLines,
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  SnapConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [{ content: 'Node 1' }],
  },
  {
    id: 'Node2',
    offsetX: 400,
    offsetY: 200,
    annotations: [{ content: 'Node 2' }],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      snapSettings=
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import {
  DiagramComponent,
  NodeModel,
  SnapConstraints,
} from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes: NodeModel[] = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [{ content: 'Node 1' }],
  },
  {
    id: 'Node2',
    offsetX: 400,
    offsetY: 200,
    annotations: [{ content: 'Node 2' }],
  },
];
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      snapSettings=
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information about snap constraints, refer to SnapConstraints.

NOTE

By default, the following constraints are enabled for the snap functionality:

* ShowLines

* ShowVerticalLines

* ShowHorizontalLines

* SnapToLines

* SnapToHorizontalLines

* SnapToVerticalLines

* SnapToObject

* All

Boundary Constraints

Boundary constraints define the interaction boundaries for diagram elements, controlling where users can perform operations.
The following list of constraints are used to enable or disable certain features of boundary interactions of the diagram.

Constraints Description
Infinity Allows interactions at infinite height and width.
Diagram Limits interactions within the diagram’s height and width.
Page Limits interactions within the page boundaries.

The following code illustrates how to limit the interaction done inside a diagram within a page.

function App() {
  return (
    <DiagramComponent
      id="container"
      width={700}
      height={600}
      pageSettings={{
        boundaryconstraints: "Page",
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);

Refer sample below

import * as React from 'react';
import * as ReactDOM from "react-dom";
import { DiagramComponent } from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [{ content: 'Node interactions restricted within page' }],
  },
];
let pageSettings = {
  boundaryConstraints: 'Page',
  width: 500,
  height: 500,
  showPageBreaks: true,
  background: { color: 'grey' }
};
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      pageSettings={pageSettings}
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { DiagramComponent, NodeModel } from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let nodes: NodeModel[] = [
  {
    id: 'Node1',
    offsetX: 200,
    offsetY: 200,
    annotations: [{ content: 'Node interactions restricted within page' }],
  },
];
let pageSettings: any = {
  boundaryConstraints: 'Page',
  width: 500,
  height: 500,
  showPageBreaks: true,
  background: { color: 'grey' }
};
// initialize Diagram component
function App() {
  return (
    <DiagramComponent
      id="container"
      width={'100%'}
      height={'600px'}
      // Add node
      nodes={nodes}
      pageSettings={pageSettings}
      getNodeDefaults={(node) => {
        node.height = 100;
        node.width = 100;
        node.style.strokeColor = 'black';
        return node;
      }}
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

For more information about boundary constraints, refer to BoundaryConstraints.

Inherit Behaviors

When behaviors are defined at both the specific object level (node/connector) and diagram level, inheritance options determine the actual behavior applied.

The following code example demonstrates how to inherit line bridging behavior from the diagram model:

let connectors: ConnectorModel[] = [{
    id: 'connector1',
    type: 'Straight',
    sourcePoint: {
        x: 100,
        y: 100
    },
    targetPoint: {
        x: 200,
        y: 200
    },
    constraints = {
        ConnectorConstraints.Default & ConnectorConstraints.InheritBridging
    }
}];
function App() {
return (
<DiagramComponent
id="container"
width={700}
height={600}
connectors={connectors}
constraints={DiagramConstraints.Default | DiagramConstraints.Bridging}
>
<Inject services={[ConnectorBridging]} />
</DiagramComponent>
);
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Bitwise Operations

Bitwise operations manipulate flagged enumerations to enable precise control over multiple constraint behaviors simultaneously.

Add Operation

Use the Bitwise | (OR) operator to add or enable multiple values:

node.constraints = NodeConstraints.Select | NodeConstraints.Rotate;

This example enables both selection and rotation operations for the node.

Remove Operation

Use the Bitwise &~ (XOR) operator to remove or disable specific values:

node.constraints = node.constraints & ~NodeConstraints.Rotate;

This example disables rotation while maintaining other enabled constraints.

Check Operation

Use the Bitwise & (AND) operator to verify if specific values are enabled:

if ((node.constraints & NodeConstraints.Rotate) == NodeConstraints.Rotate);

This example checks whether rotation constraints are enabled for a node. When the node has rotation constraints enabled, the expression returns the rotate constraint value.

Constraints in Angular Diagram Component

Constraints enable or disable specific behaviors of diagrams, nodes, and connectors. These constraints are implemented as flagged enumerations, allowing multiple behaviors to be controlled simultaneously using Bitwise operators (&, |, ~, <<, etc.).

To learn more about Bitwise operators, refer to the Bitwise Operations section.

Diagram Constraints

Diagram constraints control the overall behavior and functionality of the diagram canvas.

Constraints Description
None Disables all diagram functionalities.
Bridging Enables bridging support for connectors in the diagram.
Undo/redo Enables undo and redo functionality for diagram operations.
UserInteraction Enables user interaction capabilities for the diagram.
ApiUpdate Enables programmatic updates through API calls.
PageEditable Enables editing within the page boundaries.
Zoom Enables zooming functionality for the diagram.
PanX Enables horizontal panning of the diagram.
PanY Enables vertical panning of the diagram.
Pan Enables both horizontal and vertical panning.
ZoomTextEdit Enables text box zooming during text editing operations.
Tooltip Enables tooltip display for diagram elements.
Virtualization Enables virtualization support for large diagrams.
LineRouting Enables automatic line routing for connectors.
Default Enables all default constraints for the diagram.

The following example demonstrates how to disable page editing using diagram constraints:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { DiagramConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [constraints]='diagramConstraints'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public diagramConstraints: DiagramConstraints;
    ngOnInit(): void {
        this.diagramConstraints = DiagramConstraints.Default & ~DiagramConstraints.PageEditable;
    }
}

The following example shows how to enable bridging constraint along with the default constraints:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { DiagramConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  // specifies the template string for the diagram component
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [constraints]='diagramConstraints'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public diagramConstraints: DiagramConstraints;
    ngOnInit(): void {
        this.diagramConstraints = DiagramConstraints.Default | DiagramConstraints.Bridging
    }
}

Multiple behaviors can be added or removed from the default constraints using Bitwise operations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { DiagramConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  // specifies the template string for the diagram component
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [constraints]='diagramConstraints'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public diagramConstraints: DiagramConstraints;
    ngOnInit(): void {
        this.diagramConstraints = DiagramConstraints.Default & ~(DiagramConstraints.PageEditable | DiagramConstraints.Zoom);
    }
}

For more information about diagram constraints, refer to DiagramConstraints.

NOTE

By default, the following constraints are enabled in the diagram:

* Zoom

* ApiUpdate

* PanX

* PanY

* Pan

* Undo/Redo

* PageEditable

* Default

Node Constraints

Node constraints control the behavior and interactions available for individual nodes within the diagram.

Constraints Description
None Disables all node constraints.
Select Enables node selection capability.
Drag Enables node dragging functionality.
Rotate Enables node rotation capability.
Shadow Enables shadow display for the node.
PointerEvents Enables pointer event handling for the node.
Delete Enables node deletion capability.
InConnect Enables incoming connections to the node.
OutConnect Enables outgoing connections from the node.
AllowDrop Enables drop operations on the node.
Individual Enables individual resize handles for the node.
ResizeNorthEast Enables resizing from the northeast corner.
ResizeEast Enables resizing from the east side.
ResizeSouthEast Enables resizing from the southeast corner.
ResizeSouth Enables resizing from the south side.
ResizeSouthWest Enables resizing from the southwest corner.
ResizeWest Enables resizing from the west side.
ResizeNorthWest Enables resizing from the northwest corner.
ResizeNorth Enables resizing from the north side.
AspectRatio Maintains aspect ratio during resize operations.
ReadOnly Enables read-only mode for node annotations.
HideThumbs Hides all resize thumbs for the node.
Tooltip Enables tooltip display for the node.
InheritTooltip Inherits tooltip settings from parent objects.
Resize Enables overall resize functionality for the node.
Inherit Inherits interaction settings from parent objects.
Expandable Enables expand/collapse functionality for the node.
AllowMovingOutsideLane Allows movement outside swim lane boundaries.
Default Enables all default constraints for the node.

The following example demonstrates how to disable rotation using node constraints:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { NodeConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [constraints]='nodeConstraints'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public nodeConstraints: NodeConstraints;
    ngOnInit(): void {
        this.nodeConstraints = NodeConstraints.Default & ~NodeConstraints.Rotate;
    }
}

The following example shows how to add shadow constraint to the default node constraints:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { NodeConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [constraints]='nodeConstraints'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public nodeConstraints: NodeConstraints;
    ngOnInit(): void {
        this.nodeConstraints = NodeConstraints.Default | NodeConstraints.Shadow;
    }
}

The following code example shows how to enable tooltip for a node:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { NodeConstraints, DiagramTooltipModel } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [constraints]='nodeConstraints' [tooltip]='tooltip'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public nodeConstraints: NodeConstraints;
    public tooltip: DiagramTooltipModel;
    ngOnInit(): void {
        this.nodeConstraints = NodeConstraints.Default | NodeConstraints.Tooltip;
        this.tooltip = { content: 'Node' };
    }
}

Multiple behaviors can be added or removed from the default constraints using Bitwise operations:

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [constraints]='nodeConstraints'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public nodeConstraints: NodeConstraints;
    ngOnInit(): void {
        this.nodeConstraints = NodeConstraints.Default & ~(NodeConstraints.Rotate | NodeConstraints.Resize);
    }
}

Refer sample below

import {
    DiagramModule,
    NodeConstraints, DiagramComponent, NodeModel
  } from '@syncfusion/ej2-angular-diagrams';
  import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
  
  @Component({
    imports: [DiagramModule],
  
    providers: [],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]='nodes' [getNodeDefaults] ='getNodeDefaults'>
      </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
  })
  export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;
    public nodes: NodeModel[] = [
      {
        id: 'node1',
        offsetX: 200,
        offsetY: 100,
        annotations: [{ content: 'Select disabled' }],
        constraints: NodeConstraints.Default & ~NodeConstraints.Select,
      },
      {
        id: 'node2',
        offsetX: 500,
        offsetY: 100,
        annotations: [{ content: 'Rotate disabled' }],
        constraints: NodeConstraints.Default & ~NodeConstraints.Rotate,
      },
      {
        id: 'node3',
        offsetX: 200,
        offsetY: 400,
        annotations: [{ content: 'Resize disabled' }],
        constraints: NodeConstraints.Default & ~NodeConstraints.Resize,
      },
      {
        id: 'node4',
        offsetX: 500,
        offsetY: 400,
        annotations: [{ content: 'Drag disabled' }],
        constraints: NodeConstraints.Default & ~NodeConstraints.Drag,
      },
      {
        id: 'node5',
        offsetX: 350,
        offsetY: 250,
        annotations: [{ content: 'Tooltip disabled' }],
        constraints: NodeConstraints.Default & ~NodeConstraints.Tooltip,
        tooltip: { content: 'Node Tooltip', relativeMode: 'Object' },
      },
    ];
  
    public getNodeDefaults(node: NodeModel): NodeModel {
      node.height = 100;
      node.width = 100;
      node.pivot = { x: 0, y: 0 };
      return node;
    }
  }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information about node constraints, refer to NodeConstraints.

NOTE

By default, the following constraints are enabled for nodes:

* Select

* Drag

* Resize

* Rotate

* InConnect

* OutConnect

* PointerEvents

* ResizeNorthEast

* ResizeEast

* ResizeSouthEast

* ResizeSouth

* ResizeSouthWest

* ResizeWest

* ResizeNorthWest

* ResizeNorth

* Inherit

* Expandable

* Individual

* InheritTooltip

* Default

Connector Constraints

Connector constraints control the behavior and interactions available for connectors within the diagram.

Constraints Description
None Disables all connector constraints.
Select Enables connector selection capability.
Delete Enables connector deletion capability.
Drag Enables connector dragging functionality.
DragSourceEnd Enables dragging of the connector’s source endpoint.
DragTargetEnd Enables dragging of the connector’s target endpoint.
DragSegmentThumb Enables dragging of segment control points.
Interaction Enables general interaction capabilities for the connector.
AllowDrop Enables drop operations on the connector.
Bridging Enables bridging functionality for the connector.
InheritBridging Inherits bridging settings from parent objects.
BridgeObstacle Enables the connector to act as a bridge obstacle.
PointerEvents Enables pointer event handling for the connector.
ConnectToNearByNode Enables automatic connection to nearby nodes.
ConnectToNearByPort Enables automatic connection to nearby ports.
Tooltip Enables tooltip display for the connector.
LineRouting Enables line routing functionality for the connector.
InheritLineRouting Inherits line routing settings from parent objects.
InheritTooltip Inherits tooltip settings from parent objects.
ConnectToNearByElement Enables automatic connection to nearby elements.
InheritSegmentThumbShape Inherits segment thumb shape from parent objects.
ReadOnly Enables read-only mode for the connector.
Default Enables all default constraints for the connector.

The following code demonstrates how to disable selection using connector constraints:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { ConnectorConstraints, PointModel } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-connectors>
            <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [constraints]='connectorConstraints'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public connectorConstraints: ConnectorConstraints;
    public sourcePoint: PointModel;
    public targetPoint: PointModel;
    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
        this.connectorConstraints = ConnectorConstraints.Default & ~ConnectorConstraints.Select;
    }
}

The following example shows how to add bridging constraint to the default connector constraints:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { ConnectorConstraints, PointModel } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-connectors>
            <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [constraints]='connectorConstraints'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public connectorConstraints: ConnectorConstraints;
    public sourcePoint: PointModel;
    public targetPoint: PointModel;
    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
        this.connectorConstraints = ConnectorConstraints.Default | ConnectorConstraints.Bridging;
    }
}

NOTE

To visualize connector bridging, inject the ConnectorBridging module.

The following example shows how to enable tooltip for connectors:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { ConnectorConstraints, DiagramTooltipModel, PointModel } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-connectors>
            <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [constraints]='connectorConstraints' [tooltip]='tooltip'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public connectorConstraints: ConnectorConstraints;
    public sourcePoint: PointModel;
    public targetPoint: PointModel;
    public tooltip: DiagramTooltipModel;
    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
        this.connectorConstraints = ConnectorConstraints.Default | ConnectorConstraints.Tooltip;
        this.tooltip = { content: 'Connector' };
    }
}

Multiple behaviors can be added or removed from the default constraints using Bitwise operations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { ConnectorConstraints, PointModel } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-connectors>
            <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [constraints]='connectorConstraints'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public connectorConstraints: ConnectorConstraints;
    public sourcePoint: PointModel;
    public targetPoint: PointModel;
    ngOnInit(): void {
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
        // Removing multiple constraints from default
        this.connectorConstraints = ConnectorConstraints.Default & ~(ConnectorConstraints.DragSourceEnd | ConnectorConstraints.DragTargetEnd);
    }
}

Refer sample below

import {
  ConnectorConstraints,
  ConnectorModel,
    DiagramModule, DiagramComponent, NodeModel
  } from '@syncfusion/ej2-angular-diagrams';
  
  import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
  
  @Component({
    imports: [DiagramModule],
  
    providers: [],
    standalone: true,
    selector: 'app-container',
    template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [connectors]='connectors' [getNodeDefaults] ='getNodeDefaults'>
      </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
  })
  export class AppComponent {
    @ViewChild('diagram')
    public diagram?: DiagramComponent;
    public connectors: ConnectorModel[] = [
      {
          id: 'connector1',
          sourcePoint: { x: 100, y: 100 },
          targetPoint: { x: 200, y: 200 },
          type: 'Orthogonal',
          constraints: ConnectorConstraints.Default &~ ConnectorConstraints.Select,
          annotations: [{ content: 'Select disabled', alignment: 'After' }],
        },
        {
          id: 'connector2',
          sourcePoint: { x: 250, y: 100 },
          targetPoint: { x: 350, y: 200 },
          type: 'Orthogonal',
          constraints:
            ConnectorConstraints.Default &~ ConnectorConstraints.Drag,
          annotations: [{ content: 'Drag disabled', alignment: 'After' }],
        },
        {
          id: 'connector3',
          sourcePoint: { x: 400, y: 100 },
          targetPoint: { x: 500, y: 200 },
          type: 'Orthogonal',
          constraints: ConnectorConstraints.Default &~ ConnectorConstraints.DragSourceEnd,
          annotations: [{ content: 'Source end disabled', alignment: 'After' }],
        },
        {
          id: 'connector4',
          sourcePoint: { x: 550, y: 100 },
          targetPoint: { x: 650, y: 200 },
          type: 'Orthogonal',
          constraints: ConnectorConstraints.Default &~ ConnectorConstraints.DragTargetEnd,
          annotations: [{ content: 'Target end disabled', alignment: 'After' }],
        },
        {
          id: 'connector5',
          sourcePoint: { x: 700, y: 100 },
          targetPoint: { x: 800, y: 200 },
          type: 'Orthogonal',
          constraints: ConnectorConstraints.Default &~ ConnectorConstraints.Delete,
          annotations: [{ content: 'Delete disabled', alignment: 'After' }],
        },
    ];
  
    public getNodeDefaults(node: NodeModel): NodeModel {
      node.height = 100;
      node.width = 100;
      node.pivot = { x: 0, y: 0 };
      return node;
    }
  }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information about connector constraints, refer to ConnectorConstraints.

NOTE

By default, the following constraints are enabled for connectors:

* Select

* Delete

* Drag

* Interaction

* ConnectToNearByNode

* ConnectToNearByPort

* ConnectToNearByElement

* BridgeObstacle

* InheritBridging

* PointerEvents

* InheritLineRouting

* InheritTooltip

* InheritSegmentThumbShape

* Default

Port Constraints

Port constraints control the behavior and connection capabilities of ports attached to nodes.

Constraints Description
None Disables all port constraints.
Draw Enables connection creation when hovering over the port.
Drag Enables port dragging functionality.
InConnect Enables incoming connections to the port only.
OutConnect Enables outgoing connections from the port only.
ToolTip Enables tooltip display for the port.
InheritTooltip Inherits tooltip settings from parent objects.
Default Enables all default constraints for the port.

The following code demonstrates how to disable connection creation with a port:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { PointPortModel, PortConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [ports]='port1'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public port1: PointPortModel[];
    ngOnInit(): void {
        this.port1 = [{
            id: 'port1',
            shape: 'Circle',
            offset: { x: 0, y: 0.5 },
            text: 'In - 1',
            constraints: PortConstraints.None
        }];
    }
}

The following code example shows how to configure port constraints to accept only incoming connections:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { PointPortModel, PortConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [ports]='port1'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public port1: PointPortModel[];
    ngOnInit(): void {
        this.port1 = [{
            id: 'port1',
            shape: 'Circle',
            offset: { x: 0, y: 0.5 },
            text: 'In - 1',
            constraints: PortConstraints.InConnect
        }];
    }
}

Multiple behaviors can be combined using Bitwise operations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { PointPortModel, PortConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80 [ports]='port1'>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public port1: PointPortModel[];
    ngOnInit(): void {
        this.port1 = [{
            id: 'port1',
            shape: 'Circle',
            offset: { x: 0, y: 0.5 },
            text: 'In - 1',
            constraints: PortConstraints.Default | PortConstraints.Draw
        }];
    }
}

Refer sample below

import {
  DiagramModule,
PortConstraints,
PortVisibility,
DiagramComponent,
NodeModel
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]='nodes' [getNodeDefaults] ='getNodeDefaults'>
    </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
        id: 'Node1',
        offsetX: 200,
        offsetY: 200,
        annotations: [
          { content: 'tooltip enabled', offset: { x: 0.5, y: 0.1 } },
          { content: 'draw enabled', offset: { x: 0.2, y: 0.5 } },
          { content: 'drg enabled', offset: { x: 0.8, y: 0.5 } },
          { content: 'InConnect disabled', offset: { x: 0.2, y: 0.9 } },
          { content: 'OutConnect disabled', offset: { x: 0.8, y: 0.9 } },
        ],
        ports: [
          {
            id: 'left',
            offset: { x: 0, y: 0.5 },
            visibility: PortVisibility.Visible,
            constraints:
              PortConstraints.Default |
              PortConstraints.Draw,
          },
          {
            id: 'right',
            offset: { x: 1, y: 0.5 },
            visibility: PortVisibility.Visible,
            constraints:
              PortConstraints.Default |
              PortConstraints.Drag,
          },
          {
            id: 'top',
            offset: { x: 0.5, y: 0 },
            visibility: PortVisibility.Visible,
            constraints:
              PortConstraints.Default |
              PortConstraints.ToolTip,
            tooltip: { content: 'Port tooltip' },
          },
          {
            id: 'bottomLeft',
            offset: { x: 0.2, y: 1 },
            visibility: PortVisibility.Visible,
            constraints:PortConstraints.Default &
              ~PortConstraints.InConnect,
          },
          {
            id: 'bottomRight',
            offset: { x: 0.8, y: 1 },
            visibility: PortVisibility.Visible,
            constraints: PortConstraints.Default &
              ~PortConstraints.OutConnect,
          },
        ],
      },
  ];

  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 200;
    node.width = 300;
    node.pivot = { x: 0, y: 0 };
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information about port constraints, refer to PortConstraints.

NOTE

By default, the following constraints are enabled for ports:

* InConnect

* OutConnect

Annotation Constraints

Annotation constraints control the behavior and edit ability of text annotations on nodes and connectors.

Constraints Description
ReadOnly Enables read-only mode for the annotation.
InheritReadOnly Inherits read-only settings from parent objects.
Select Enables selection capability for the annotation.
Drag Enables dragging functionality for the annotation.
Resize Enables resize capability for the annotation.
Rotate Enables rotation capability for the annotation.
Interaction Enables general interaction capabilities for the annotation.
None Disables all constraints for the annotation.

The following code demonstrates how to enable read-only mode for annotations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { AnnotationConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80>
                <e-node-annotations>
                    <e-node-annotation content='Start' [constraints]='annotationConstraints'></e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public annotationConstraints: AnnotationConstraints;
    ngOnInit(): void {
        this.annotationConstraints = AnnotationConstraints.ReadOnly;
    }
}

The following example shows how to enable multiple interactions for annotations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { AnnotationConstraints } from "@syncfusion/ej2-angular-diagrams";

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px">
        <e-nodes>
            <e-node id='node1' [height]=60 [width]=100 [offsetX]=300 [offsetY]=80>
                <e-node-annotations>
                    <e-node-annotation content='Start' [constraints]='annotationConstraints'></e-node-annotation>
                </e-node-annotations>
            </e-node>
        </e-nodes>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public annotationConstraints: AnnotationConstraints;
    ngOnInit(): void {
        this.annotationConstraints = AnnotationConstraints.Select | AnnotationConstraints.Drag | AnnotationConstraints.Resize | AnnotationConstraints.Rotate;
    }
}

Refer sample below

import {
  AnnotationConstraints,
  DiagramModule, DiagramComponent, NodeModel
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]='nodes' [getNodeDefaults] ='getNodeDefaults'>
          </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public nodes: NodeModel[] = [
    {
      id: 'Node1',
      offsetX: 200,
      offsetY: 200,
      annotations: [
        {
          content: 'Interaction enabled',
          offset: { x: 0.5, y: 0.1 },
          constraints: AnnotationConstraints.Interaction,
        },
        {
          content: 'ReadOnly enabled',
          offset: { x: 0.2, y: 0.5 },
          constraints: AnnotationConstraints.ReadOnly,
        },
        {
          content: 'Select and drag enabled',
          offset: { x: 0.8, y: 0.5 },
          constraints:
            AnnotationConstraints.Select |
            AnnotationConstraints.Drag,
        },
        {
          content: 'Select and rotate enabled',
          offset: { x: 0.5, y: 0.9 },
          constraints:
            AnnotationConstraints.Select |
            AnnotationConstraints.Rotate,
        },
      ],
    },
  ];

  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 200;
    node.width = 300;
    node.pivot = { x: 0, y: 0 };
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more details about annotation constraints, refer to AnnotationConstraints.

Selector Constraints

Selector constraints control the visibility and behavior of selection handles and thumbs that appear when elements are selected.

Constraints Description
None Hides all selector elements.
ConnectorSourceThumb Shows or hides the connector’s source thumb.
ConnectorTargetThumb Shows or hides the connector’s target thumb.
ResizeSouthEast Shows or hides the bottom-right resize handle.
ResizeSouthWest Shows or hides the bottom-left resize handle.
ResizeNorthEast Shows or hides the top-right resize handle.
ResizeNorthWest Shows or hides the top-left resize handle.
ResizeEast Shows or hides the middle-right resize handle.
ResizeWest Shows or hides the middle-left resize handle.
ResizeSouth Shows or hides the bottom-center resize handle.
ResizeNorth Shows or hides the top-center resize handle.
Rotate Shows or hides the rotation handle.
UserHandle Shows or hides custom user handles.
ToolTip Shows or hides tooltips during drag, resize, and rotate operations.
ResizeAll Shows or hides all resize handles.
All Shows all available handles.

The following code demonstrates how to hide the rotation handle:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { SelectorModel, SelectorConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [selectedItems]='selectedItems'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public selectedItems: SelectorModel;
    ngOnInit(): void {
        this.selectedItems = { constraints: SelectorConstraints.All & ~SelectorConstraints.Rotate };
    }
}

The following code shows how to hide the default tooltip during drag, resize, and rotate operations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { SelectorModel, SelectorConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [selectedItems]='selectedItems'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public selectedItems: SelectorModel;
    ngOnInit(): void {
        this.selectedItems = { constraints: SelectorConstraints.All & ~SelectorConstraints.Tooltip };
    }
}

The following code example shows how to disable user handle functionality:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { SelectorModel, SelectorConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [selectedItems]='selectedItems'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public selectedItems: SelectorModel;
    ngOnInit(): void {
        this.selectedItems = { constraints: SelectorConstraints.All & ~SelectorConstraints.UserHandle };
    }
}

Refer sample below

import {
  DiagramModule,
  SelectorConstraints,
  SelectorModel, DiagramComponent, NodeModel
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]='nodes' [getNodeDefaults] ='getNodeDefaults' [selectedItems]='selectedItems'>
        </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public selectedItems?: SelectorModel;
  public nodes: NodeModel[] = [
    {
      id: 'Node1',
      offsetX: 200,
      offsetY: 200,
      annotations: [
        { content: 'Resize handle disabled in selector constraints' },
      ],
    },
  ];
  ngOnInit(): void {
    this.selectedItems = {
      constraints: SelectorConstraints.All & ~SelectorConstraints.ResizeAll,
    };
  }
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    node.pivot = { x: 0, y: 0 };
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information about selector constraints, refer to SelectorConstraints.

NOTE

By default, the following constraints are enabled for selected items:

* Rotate

* UserHandle

* ResizeAll

* All

* ToolTip

Snap Constraints

Snap constraints control the visibility of gridlines and enable or disable snapping functionality for precise element positioning.

Constraints Description
None Disables snapping for all diagram elements.
ShowHorizontalLines Displays horizontal gridlines in the diagram.
ShowVerticalLines Displays vertical gridlines in the diagram.
ShowLines Displays both horizontal and vertical gridlines.
SnapToHorizontalLines Enables snapping to horizontal gridlines only.
SnapToVerticalLines Enables snapping to vertical gridlines only.
SnapToLines Enables snapping to both horizontal and vertical gridlines.
SnapToObject Enables snapping to other objects in the diagram.
All Shows gridlines and enables all snapping functionality.

The following code demonstrates how to show only horizontal gridlines:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { SnapSettingsModel, SnapConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [snapSettings]='snapSettings'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public snapSettings: SnapSettingsModel;
    ngOnInit(): void {
        this.snapSettings = {
            constraints: SnapConstraints.ShowHorizontalLines
        };
    }
}

Multiple snap behaviors can be combined using Bitwise operations:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { SnapSettingsModel, SnapConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [snapSettings]='snapSettings'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public snapSettings: SnapSettingsModel;
    ngOnInit(): void {
        this.snapSettings = {
            constraints: SnapConstraints.ShowHorizontalLines | SnapConstraints.ShowVerticalLines
        };
    }
}

Refer sample below

import {
  DiagramModule,
  SnapConstraints,
  SnapSettingsModel,
  DiagramComponent, 
  NodeModel
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]='nodes' [getNodeDefaults] ='getNodeDefaults' [snapSettings]='snapSettings'>
        </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public snapSettings?: SnapSettingsModel;
  ngOnInit(): void {
    this.snapSettings = {
      constraints: SnapConstraints.ShowHorizontalLines | SnapConstraints.SnapToObject
    };
  }
  public nodes: NodeModel[] = [
    {
      id: 'Node1',
      offsetX: 200,
      offsetY: 200,
      annotations: [{ content: 'Node 1' }],
    },
    {
      id: 'Node2',
      offsetX: 400,
      offsetY: 200,
      annotations: [{ content: 'Node 2' }],
    },
  ];
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    node.pivot = { x: 0, y: 0 };
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information about snap constraints, refer to SnapConstraints.

NOTE

By default, the following constraints are enabled for snap functionality:

* ShowLines

* ShowVerticalLines

* ShowHorizontalLines

* SnapToLines

* SnapToHorizontalLines

* SnapToVerticalLines

* SnapToObject

* All

Boundary Constraints

Boundary constraints define the interaction boundaries for diagram elements, controlling where users can perform operations.

Constraints Description
Infinity Allows interactions at infinite height and width.
Diagram Limits interactions within the diagram’s height and width.
Page Limits interactions within the page boundaries.

The following code demonstrates how to limit interactions within page boundaries:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { PageSettingsModel, BoundaryConstraints } from '@syncfusion/ej2-diagrams';
@Component({
  selector: "app-container",
  template: `<ejs-diagram id="diagram" width="100%" height="580px" [pageSettings]='pageSettings'></ejs-diagram>`
})
export class AppComponent {
    @ViewChild("diagram")
    public pageSettings: PageSettingsModel;
    ngOnInit(): void {
        this.pageSettings = {
            boundaryConstraints: 'Page'
        };
    }
}

Refer sample below

import {
  DiagramModule,
  PageSettingsModel, DiagramComponent, NodeModel
} from '@syncfusion/ej2-angular-diagrams';

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

@Component({
  imports: [DiagramModule],

  providers: [],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="580px" [nodes]='nodes' [getNodeDefaults] ='getNodeDefaults' [pageSettings]='pageSettings'>
        </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram')
  public diagram?: DiagramComponent;
  public pageSettings?: PageSettingsModel;
  ngOnInit(): void {
    this.pageSettings = {
      boundaryConstraints: 'Page',
      width: 500,
      height: 500,
      showPageBreaks: true,
      background: { color: 'grey' },
    };
  }
  public nodes: NodeModel[] = [
    {
      id: 'Node1',
      offsetX: 200,
      offsetY: 200,
      annotations: [{ content: 'Node 1' }],
    }
  ];
  public getNodeDefaults(node: NodeModel): NodeModel {
    node.height = 100;
    node.width = 100;
    node.pivot = { x: 0, y: 0 };
    return node;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

For more information about boundary constraints, refer to BoundaryConstraints.

Inherit Behaviors

When behaviors are defined at both the specific object level (node/connector) and diagram level, inheritance options determine the actual behavior applied.

The following code example demonstrates how to inherit line bridging behavior from the diagram model:

import { Component, ViewEncapsulation, ViewChild } from "@angular/core";
import { DiagramConstraints, ConnectorBridging, ConnectorConstraints, PointModel } from "@syncfusion/ej2-angular-diagrams";
Diagram.Inject(ConnectorBridging);

@Component({
    selector: "app-container",
    template: `<ejs-diagram id="diagram" width="100%" height="580px" [constraints]='diagramConstraints'>
        <e-connectors>
            <e-connector id='connector' type='Straight' [sourcePoint]='sourcePoint' [targetPoint]='targetPoint' [constraints]='connectorConstraints'>
            </e-connector>
        </e-connectors>
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagramConstraints: DiagramConstraints;
    public connectorConstraints: ConnectorConstraints;
    public sourcePoint: PointModel;
    public targetPoint: PointModel;
    ngOnInit(): void {
        this.diagramConstraints = DiagramConstraints.Default | DiagramConstraints.Bridging;
        this.sourcePoint = { x: 100, y: 100 };
        this.targetPoint = { x: 200, y: 200 };
        this.connectorConstraints = ConnectorConstraints.Default | ConnectorConstraints.InheritBridging;
    }
}

Bitwise Operations

Bitwise operations manipulate flagged enumerations to enable precise control over multiple constraint behaviors simultaneously.

Add operation

Use the Bitwise | (OR) operator to add or enable multiple values:

node.constraints = NodeConstraints.Select | NodeConstraints.Rotate;

This example enables both selection and rotation operations for the node.

Remove operation

Use the Bitwise &~ (XOR) operator to remove or disable specific values:

node.constraints = node.constraints & ~(NodeConstraints.Rotate);

This example disables rotation while maintaining other enabled constraints.

Check operation

Use the Bitwise & (AND) operator to verify if specific values are enabled:

if ((node.constraints & (NodeConstraints.Rotate)) == (NodeConstraints.Rotate));

This example checks whether rotation constraints are enabled for a node. When the node has rotation constraints enabled, the expression returns the rotate constraint value.